/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 79 "cfg.y" /* yacc.c:339  */


#include <stdlib.h>
#include <stdio.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "route.h"
#include "dprint.h"
#include "cfg_pp.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "pt_scaling.h"
#include "dset.h"
#include "pvar.h"
#include "blacklists.h"
#include "xlog.h"
#include "db/db_insertq.h"
#include "bin_interface.h"
#include "net/trans.h"
#include "config.h"
#include "mem/rpm_mem.h"
#include "poll_types.h"

#ifdef SHM_EXTRA_STATS
#include "mem/module_info.h"
#endif

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#undef MIN
#undef MAX

extern int yylex();
static void yyerror(char* s);
static void yyerrorf(char* fmt, ...);
static char* tmp;
static int i_tmp, rc;
static void* cmd_tmp;
static struct socket_id* lst_tmp;
static int rt;  /* Type of route block for find_export */
static str s_tmp;
static str tstr;
static struct net* net_tmp;
static pv_spec_t *spec;
static pv_elem_t *elem;
static struct bl_rule *bl_head = 0;
static struct bl_rule *bl_tail = 0;

action_elem_t elems[MAX_ACTION_ELEMS];
static action_elem_t route_elems[MAX_ACTION_ELEMS];
action_elem_t *a_tmp;

static inline void warn(char* s);
static struct socket_id* mk_listen_id(char*, enum sip_protos, int);
static struct socket_id* set_listen_id_adv(struct socket_id *, char *, int);
static struct multi_str *new_string(char *s);
static int parse_ipnet(char *in, int len, struct net **ipnet);

extern int line;
extern int column;
extern int startcolumn;
extern char *finame;

struct listen_param {
	enum si_flags flags;
	int workers;
	struct socket_id *socket;
	char *tag;
	char *auto_scaling_profile;
} p_tmp;
static void fill_socket_id(struct listen_param *param, struct socket_id *s);

union route_name_var {
	int iname;
	struct _pv_spec *sname;
	struct _pv_elem *ename;
	void *data;
} rn_tmp;

#ifndef SHM_EXTRA_STATS
struct multi_str{
	char *s;
	struct multi_str* next;
};
#else
static struct multi_str *tmp_mod;
#endif

#define get_cfg_file_name \
	((finame) ? finame : cfg_file ? cfg_file : "default")



#define mk_action_(_res, _type, _no, _elems) \
	do { \
		_res = mk_action(_type, _no, _elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action0(_res, _type) \
	do { \
		_res = mk_action(_type, 0, 0, line, get_cfg_file_name); \
	} while(0)
#define mk_action1(_res, _type, _p1_type, _p1) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		_res = mk_action(_type, 1, elems, line, get_cfg_file_name); \
	} while(0)
#define	mk_action2(_res, _type, _p1_type, _p2_type, _p1, _p2) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		_res = mk_action(_type, 2, elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action3(_res, _type, _p1_type, _p2_type, _p3_type, _p1, _p2, _p3) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		elems[2].type = _p3_type; \
		elems[2].u.data = _p3; \
		_res = mk_action(_type, 3, elems, line, get_cfg_file_name); \
	} while(0)

extern int cfg_parse_only_routes;
#define IFOR(_instr) \
	if (cfg_parse_only_routes==1) {_instr;break;}


#line 217 "cfg.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cfg.tab.h".  */
#ifndef YY_YY_CFG_TAB_H_INCLUDED
# define YY_YY_CFG_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    DROP = 258,
    ASSERT = 259,
    EXIT = 260,
    RETURN = 261,
    LOG_TOK = 262,
    ERROR = 263,
    ROUTE = 264,
    ROUTE_FAILURE = 265,
    ROUTE_ONREPLY = 266,
    ROUTE_BRANCH = 267,
    ROUTE_ERROR = 268,
    ROUTE_LOCAL = 269,
    ROUTE_STARTUP = 270,
    ROUTE_TIMER = 271,
    ROUTE_EVENT = 272,
    IF = 273,
    ELSE = 274,
    SWITCH = 275,
    CASE = 276,
    DEFAULT = 277,
    BREAK = 278,
    WHILE = 279,
    FOR = 280,
    IN = 281,
    NULLV = 282,
    XDBG = 283,
    XLOG = 284,
    XLOG_BUF_SIZE = 285,
    XLOG_FORCE_COLOR = 286,
    XLOG_PRINT_LEVEL = 287,
    XLOG_LEVEL = 288,
    PV_PRINT_BUF_SIZE = 289,
    DEBUG_MODE = 290,
    ENABLE_ASSERTS = 291,
    ABORT_ON_ASSERT = 292,
    LOGLEVEL = 293,
    LOGPREFIX = 294,
    LOGSTDOUT = 295,
    LOGSTDERROR = 296,
    LOGFACILITY = 297,
    LOGNAME = 298,
    AVP_ALIASES = 299,
    LISTEN = 300,
    SOCKET = 301,
    MEMGROUP = 302,
    ALIAS = 303,
    AUTO_ALIASES = 304,
    TAG = 305,
    DNS = 306,
    REV_DNS = 307,
    DNS_TRY_IPV6 = 308,
    DNS_TRY_NAPTR = 309,
    DNS_RETR_TIME = 310,
    DNS_RETR_NO = 311,
    DNS_SERVERS_NO = 312,
    DNS_USE_SEARCH = 313,
    MAX_WHILE_LOOPS = 314,
    UDP_WORKERS = 315,
    CHECK_VIA = 316,
    SHM_HASH_SPLIT_PERCENTAGE = 317,
    SHM_SECONDARY_HASH_SIZE = 318,
    MEM_WARMING_ENABLED = 319,
    MEM_WARMING_PATTERN_FILE = 320,
    MEM_WARMING_PERCENTAGE = 321,
    RPM_MEM_FILE = 322,
    RPM_MEM_SIZE = 323,
    MEMLOG = 324,
    MEMDUMP = 325,
    EXECMSGTHRESHOLD = 326,
    EXECDNSTHRESHOLD = 327,
    TCPTHRESHOLD = 328,
    EVENT_SHM_THRESHOLD = 329,
    EVENT_PKG_THRESHOLD = 330,
    QUERYBUFFERSIZE = 331,
    QUERYFLUSHTIME = 332,
    SIP_WARNING = 333,
    SERVER_SIGNATURE = 334,
    SERVER_HEADER = 335,
    USER_AGENT_HEADER = 336,
    LOADMODULE = 337,
    MPATH = 338,
    MODPARAM = 339,
    MAXBUFFER = 340,
    CHROOT = 341,
    WDIR = 342,
    MHOMED = 343,
    POLL_METHOD = 344,
    TCP_ACCEPT_ALIASES = 345,
    TCP_WORKERS = 346,
    TCP_CONNECT_TIMEOUT = 347,
    TCP_CON_LIFETIME = 348,
    TCP_SOCKET_BACKLOG = 349,
    TCP_MAX_CONNECTIONS = 350,
    TCP_NO_NEW_CONN_BFLAG = 351,
    TCP_NO_NEW_CONN_RPLFLAG = 352,
    TCP_KEEPALIVE = 353,
    TCP_KEEPCOUNT = 354,
    TCP_KEEPIDLE = 355,
    TCP_KEEPINTERVAL = 356,
    TCP_MAX_MSG_TIME = 357,
    TCP_PARALLEL_READ_ON_WORKERS = 358,
    ADVERTISED_ADDRESS = 359,
    ADVERTISED_PORT = 360,
    DISABLE_CORE = 361,
    OPEN_FD_LIMIT = 362,
    MCAST_LOOPBACK = 363,
    MCAST_TTL = 364,
    TOS = 365,
    DISABLE_DNS_FAILOVER = 366,
    DISABLE_DNS_BLACKLIST = 367,
    DST_BLACKLIST = 368,
    DISABLE_STATELESS_FWD = 369,
    DB_VERSION_TABLE = 370,
    DB_DEFAULT_URL = 371,
    DB_MAX_ASYNC_CONNECTIONS = 372,
    DISABLE_503_TRANSLATION = 373,
    SYNC_TOKEN = 374,
    ASYNC_TOKEN = 375,
    LAUNCH_TOKEN = 376,
    AUTO_SCALING_PROFILE = 377,
    AUTO_SCALING_CYCLE = 378,
    TIMER_WORKERS = 379,
    EQUAL = 380,
    EQUAL_T = 381,
    GT = 382,
    LT = 383,
    GTE = 384,
    LTE = 385,
    DIFF = 386,
    MATCH = 387,
    NOTMATCH = 388,
    COLONEQ = 389,
    PLUSEQ = 390,
    MINUSEQ = 391,
    SLASHEQ = 392,
    MULTEQ = 393,
    MODULOEQ = 394,
    BANDEQ = 395,
    BOREQ = 396,
    BXOREQ = 397,
    OR = 398,
    AND = 399,
    BOR = 400,
    BAND = 401,
    BXOR = 402,
    BLSHIFT = 403,
    BRSHIFT = 404,
    PLUS = 405,
    MINUS = 406,
    SLASH = 407,
    MULT = 408,
    MODULO = 409,
    NOT = 410,
    BNOT = 411,
    RPAREN = 412,
    NUMBER = 413,
    ZERO = 414,
    ID = 415,
    STRING = 416,
    SCRIPTVAR = 417,
    IPV6ADDR = 418,
    IPV4ADDR = 419,
    IPNET = 420,
    COMMA = 421,
    SEMICOLON = 422,
    LPAREN = 423,
    LBRACE = 424,
    RBRACE = 425,
    LBRACK = 426,
    RBRACK = 427,
    AS = 428,
    USE_WORKERS = 429,
    USE_AUTO_SCALING_PROFILE = 430,
    MAX = 431,
    MIN = 432,
    DOT = 433,
    CR = 434,
    COLON = 435,
    ANY = 436,
    ANYCAST = 437,
    FRAG = 438,
    SCRIPTVARERR = 439,
    SCALE_UP_TO = 440,
    SCALE_DOWN_TO = 441,
    ON = 442,
    CYCLES = 443,
    CYCLES_WITHIN = 444,
    PERCENTAGE = 445
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 231 "cfg.y" /* yacc.c:355  */

	long intval;
	unsigned long uval;
	char* strval;
	struct expr* expr;
	struct action* action;
	struct net* ipnet;
	struct ip_addr* ipaddr;
	struct socket_id* sockid;
	struct listen_param* listen_param;
	struct _pv_spec *specval;
	struct multi_str* multistr;

#line 462 "cfg.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CFG_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 479 "cfg.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  208
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2195

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  191
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  85
/* YYNRULES -- Number of rules.  */
#define YYNRULES  474
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  910

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   445

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   483,   483,   486,   487,   488,   491,   492,   493,   493,
     494,   494,   495,   495,   496,   496,   497,   497,   498,   498,
     499,   499,   500,   500,   501,   501,   503,   506,   521,   530,
     545,   546,   549,   550,   564,   569,   579,   580,   583,   584,
     585,   589,   591,   593,   598,   604,   606,   610,   612,   614,
     616,   620,   623,   624,   627,   629,   631,   637,   640,   643,
     646,   649,   652,   657,   658,   661,   662,   663,   663,   668,
     668,   675,   676,   678,   679,   682,   690,   701,   702,   703,
     707,   715,   723,   729,   737,   741,   753,   754,   755,   756,
     757,   758,   762,   764,   767,   768,   772,   773,   779,   780,
     781,   782,   783,   784,   785,   786,   787,   788,   789,   790,
     791,   792,   793,   794,   795,   796,   797,   798,   799,   800,
     801,   802,   803,   807,   808,   811,   815,   816,   817,   825,
     833,   841,   849,   857,   865,   873,   881,   889,   897,   900,
     901,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   925,   926,   940,   941,   942,   943,   944,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   965,   975,   976,   981,   982,   985,   989,   990,   995,
     996,   999,  1000,  1003,  1004,  1007,  1008,  1015,  1016,  1023,
    1025,  1028,  1029,  1032,  1033,  1036,  1039,  1046,  1047,  1054,
    1055,  1062,  1063,  1065,  1066,  1070,  1071,  1074,  1075,  1077,
    1078,  1080,  1082,  1084,  1085,  1086,  1087,  1089,  1090,  1097,
    1100,  1108,  1111,  1155,  1156,  1161,  1163,  1165,  1166,  1172,
    1174,  1188,  1190,  1193,  1194,  1197,  1198,  1205,  1206,  1213,
    1214,  1218,  1246,  1247,  1249,  1250,  1253,  1254,  1257,  1258,
    1268,  1270,  1272,  1273,  1275,  1276,  1278,  1281,  1283,  1286,
    1287,  1290,  1292,  1295,  1298,  1302,  1303,  1309,  1315,  1319,
    1320,  1323,  1339,  1355,  1356,  1359,  1365,  1375,  1385,  1396,
    1399,  1408,  1413,  1436,  1441,  1449,  1465,  1468,  1474,  1477,
    1485,  1491,  1494,  1500,  1503,  1511,  1514,  1522,  1525,  1533,
    1536,  1549,  1552,  1558,  1563,  1564,  1565,  1566,  1567,  1568,
    1571,  1572,  1575,  1576,  1577,  1578,  1580,  1581,  1584,  1585,
    1588,  1589,  1590,  1593,  1609,  1614,  1615,  1616,  1618,  1623,
    1626,  1629,  1632,  1635,  1641,  1642,  1643,  1644,  1645,  1646,
    1647,  1648,  1649,  1650,  1654,  1655,  1656,  1657,  1658,  1659,
    1662,  1665,  1668,  1671,  1674,  1677,  1680,  1683,  1686,  1689,
    1692,  1695,  1708,  1721,  1743,  1744,  1745,  1746,  1747,  1750,
    1751,  1752,  1755,  1756,  1757,  1760,  1761,  1762,  1766,  1767,
    1768,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1781,
    1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,  1792,  1800,
    1810,  1818,  1828,  1836,  1854,  1863,  1864,  1866,  1867,  1870,
    1876,  1882,  1888,  1896,  1899,  1902,  1907,  1917,  1924,  1931,
    1941,  1946,  1953,  1963,  1968,  1975,  1987,  1992,  1997,  2002,
    2007,  2017,  2027,  2037,  2049,  2067,  2098,  2102,  2108,  2111,
    2112,  2113,  2114,  2115,  2117,  2119,  2121,  2123,  2125,  2126,
    2129,  2135,  2136,  2138,  2144,  2145,  2147,  2151,  2170,  2171,
    2173,  2196,  2232,  2234,  2237,  2239,  2241,  2243,  2245,  2247,
    2249,  2255,  2261,  2267,  2273
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "DROP", "ASSERT", "EXIT", "RETURN",
  "LOG_TOK", "ERROR", "ROUTE", "ROUTE_FAILURE", "ROUTE_ONREPLY",
  "ROUTE_BRANCH", "ROUTE_ERROR", "ROUTE_LOCAL", "ROUTE_STARTUP",
  "ROUTE_TIMER", "ROUTE_EVENT", "IF", "ELSE", "SWITCH", "CASE", "DEFAULT",
  "BREAK", "WHILE", "FOR", "IN", "NULLV", "XDBG", "XLOG", "XLOG_BUF_SIZE",
  "XLOG_FORCE_COLOR", "XLOG_PRINT_LEVEL", "XLOG_LEVEL",
  "PV_PRINT_BUF_SIZE", "DEBUG_MODE", "ENABLE_ASSERTS", "ABORT_ON_ASSERT",
  "LOGLEVEL", "LOGPREFIX", "LOGSTDOUT", "LOGSTDERROR", "LOGFACILITY",
  "LOGNAME", "AVP_ALIASES", "LISTEN", "SOCKET", "MEMGROUP", "ALIAS",
  "AUTO_ALIASES", "TAG", "DNS", "REV_DNS", "DNS_TRY_IPV6", "DNS_TRY_NAPTR",
  "DNS_RETR_TIME", "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH",
  "MAX_WHILE_LOOPS", "UDP_WORKERS", "CHECK_VIA",
  "SHM_HASH_SPLIT_PERCENTAGE", "SHM_SECONDARY_HASH_SIZE",
  "MEM_WARMING_ENABLED", "MEM_WARMING_PATTERN_FILE",
  "MEM_WARMING_PERCENTAGE", "RPM_MEM_FILE", "RPM_MEM_SIZE", "MEMLOG",
  "MEMDUMP", "EXECMSGTHRESHOLD", "EXECDNSTHRESHOLD", "TCPTHRESHOLD",
  "EVENT_SHM_THRESHOLD", "EVENT_PKG_THRESHOLD", "QUERYBUFFERSIZE",
  "QUERYFLUSHTIME", "SIP_WARNING", "SERVER_SIGNATURE", "SERVER_HEADER",
  "USER_AGENT_HEADER", "LOADMODULE", "MPATH", "MODPARAM", "MAXBUFFER",
  "CHROOT", "WDIR", "MHOMED", "POLL_METHOD", "TCP_ACCEPT_ALIASES",
  "TCP_WORKERS", "TCP_CONNECT_TIMEOUT", "TCP_CON_LIFETIME",
  "TCP_SOCKET_BACKLOG", "TCP_MAX_CONNECTIONS", "TCP_NO_NEW_CONN_BFLAG",
  "TCP_NO_NEW_CONN_RPLFLAG", "TCP_KEEPALIVE", "TCP_KEEPCOUNT",
  "TCP_KEEPIDLE", "TCP_KEEPINTERVAL", "TCP_MAX_MSG_TIME",
  "TCP_PARALLEL_READ_ON_WORKERS", "ADVERTISED_ADDRESS", "ADVERTISED_PORT",
  "DISABLE_CORE", "OPEN_FD_LIMIT", "MCAST_LOOPBACK", "MCAST_TTL", "TOS",
  "DISABLE_DNS_FAILOVER", "DISABLE_DNS_BLACKLIST", "DST_BLACKLIST",
  "DISABLE_STATELESS_FWD", "DB_VERSION_TABLE", "DB_DEFAULT_URL",
  "DB_MAX_ASYNC_CONNECTIONS", "DISABLE_503_TRANSLATION", "SYNC_TOKEN",
  "ASYNC_TOKEN", "LAUNCH_TOKEN", "AUTO_SCALING_PROFILE",
  "AUTO_SCALING_CYCLE", "TIMER_WORKERS", "EQUAL", "EQUAL_T", "GT", "LT",
  "GTE", "LTE", "DIFF", "MATCH", "NOTMATCH", "COLONEQ", "PLUSEQ",
  "MINUSEQ", "SLASHEQ", "MULTEQ", "MODULOEQ", "BANDEQ", "BOREQ", "BXOREQ",
  "OR", "AND", "BOR", "BAND", "BXOR", "BLSHIFT", "BRSHIFT", "PLUS",
  "MINUS", "SLASH", "MULT", "MODULO", "NOT", "BNOT", "RPAREN", "NUMBER",
  "ZERO", "ID", "STRING", "SCRIPTVAR", "IPV6ADDR", "IPV4ADDR", "IPNET",
  "COMMA", "SEMICOLON", "LPAREN", "LBRACE", "RBRACE", "LBRACK", "RBRACK",
  "AS", "USE_WORKERS", "USE_AUTO_SCALING_PROFILE", "MAX", "MIN", "DOT",
  "CR", "COLON", "ANY", "ANYCAST", "FRAG", "SCRIPTVARERR", "SCALE_UP_TO",
  "SCALE_DOWN_TO", "ON", "CYCLES", "CYCLES_WITHIN", "PERCENTAGE",
  "$accept", "cfg", "statements", "statement", "$@1", "$@2", "$@3", "$@4",
  "$@5", "$@6", "$@7", "$@8", "$@9", "listen_id", "host_sep", "host",
  "proto", "port", "snumber", "phostport", "panyhostport", "alias_def",
  "id_lst", "listen_id_def", "socket_def_param", "socket_def_params",
  "socket_def", "$@10", "$@11", "any_proto", "multi_string", "blst_elem",
  "blst_elem_list", "auto_scale_profile_def", "assign_stm", "module_stm",
  "ip", "ipv4", "ipv6addr", "ipv6", "ipnet", "folded_string", "route_name",
  "route_name_var", "route_stm", "failure_route_stm", "onreply_route_stm",
  "branch_route_stm", "error_route_stm", "local_route_stm",
  "startup_route_stm", "timer_route_stm", "event_route_stm", "exp",
  "equalop", "compop", "matchop", "intop", "strop", "script_var",
  "exp_elem", "exp_cond", "assignop", "assignexp", "assign_cmd", "exp_stm",
  "brk_stm", "stm", "actions", "brk_actions", "action", "brk_action",
  "brk_if_cmd", "if_cmd", "while_cmd", "foreach_cmd", "switch_cmd",
  "switch_stm", "case_stms", "case_stm", "default_stm", "func_param",
  "route_param", "async_func", "cmd", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445
};
# endif

#define YYPACT_NINF -724

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-724)))

#define YYTABLE_NINF -414

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2016,   -84,   -75,   -72,   -67,   -40,   -24,   -16,    -4,     8,
      10,    34,   179,   189,   210,   221,   236,   241,   246,   253,
     270,   273,   284,   252,   288,   305,   349,   387,   423,   304,
     343,   347,   351,   434,   484,   497,   502,   545,   549,   565,
     568,   571,   577,   590,   599,   606,   610,   623,   652,   657,
     658,   666,    25,   668,    68,   682,   685,   694,   713,   714,
     718,   723,   724,   736,   737,   745,   753,   757,   765,   766,
     774,   781,   782,   787,   790,   791,   802,   805,   808,   813,
     823,   510,   539,   831,   836,   840,   843,   845,   848,   849,
     853,   854,  -724,    82,  1887,  -724,   441,   628,   692,   696,
     626,   704,   706,   837,   824,  -724,  -724,  -724,    14,    98,
     187,   283,   286,   302,   338,   340,   578,   135,   350,   355,
     139,   137,   307,   311,   707,    20,   357,   367,   371,  -724,
     760,  -724,   792,  -724,   811,  -724,   827,  -724,   830,  -724,
     832,   386,   388,   396,   400,   415,   418,   150,   419,   152,
     420,   336,   342,   421,   435,   448,   452,   453,   457,   465,
     482,   483,   156,   157,  -724,  -724,   159,  -724,   820,   494,
      13,    87,   508,    99,   509,   513,   541,   542,   548,   552,
     167,   245,   561,   562,   564,   574,   579,   581,    74,   583,
     593,   594,   595,   607,   315,  -724,   833,  -724,   835,   834,
     838,   196,   231,   611,   612,   325,   616,   841,  -724,   -84,
    -724,    21,  -724,    29,  -724,    27,  -724,    31,  -724,    51,
    -724,    59,  -724,    80,  -724,    47,  -724,    48,  -724,  -724,
    -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,
    -724,  -724,  -724,  -724,  -724,   852,   856,  -724,  -724,  -724,
    -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,
     994,  -724,   818,   662,   690,  -724,  -724,  -724,   839,  -724,
     858,  -724,  -724,  -724,   857,   859,  -724,  -108,   861,  -724,
     768,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,
    -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,
    -724,   828,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,
    -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,
    -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,
    -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,
    -724,  -724,  -724,  -724,  -724,  -724,   846,  -724,  -724,  -724,
    -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,
    -724,  -724,  -724,   842,  -724,  -724,  -724,  -724,  -724,  -724,
    -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,
    -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,
    -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,
    -724,  -724,  -724,  -724,  -724,  -724,   863,  -724,  -724,  -724,
    -724,  -724,  -724,  -724,  -724,  -724,  -724,   817,  -724,  -724,
    -724,   869,  -724,  1724,   806,  -724,   806,  -724,  1724,   806,
    -724,   806,  -724,  1724,  -724,  1724,  -724,  1724,  -724,   806,
    -724,   806,  -724,  -724,  -724,   844,   728,   728,   232,   860,
     948,  -724,   328,   873,   948,  -724,   874,   855,   885,   877,
     890,   889,   883,   894,   895,   576,    72,    86,    89,   898,
     906,   909,   912,   913,   917,   919,   922,    94,  -724,  -724,
    -724,  1102,   908,   596,  -724,  -724,  -724,  -724,  -724,    22,
    -724,  -724,  -724,   923,   924,   625,   925,   926,   793,   822,
     851,   928,   938,   911,   933,   954,   948,   957,   960,  -724,
    -724,   728,  -724,  -724,  -724,   956,  -724,  -724,   941,  -724,
    -724,  -724,   958,  -724,   369,   942,  -724,   968,  1248,   971,
     592,  -724,  -724,  -724,   301,  -724,   243,  -724,     3,  1248,
    -137,  1248,  -137,   970,   987,   990,   990,  -724,   249,  1124,
    1125,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  1384,
    -724,  -724,  -724,  -724,  -724,  -724,   986,   991,  -724,   999,
    1000,  -724,  -724,  -724,   998,  1001,   184,     4,  -724,   992,
    -724,  -724,  -724,  -724,  -724,    12,   716,  1003,  -118,  -724,
      61,  1015,  -724,  1248,  1248,  1474,  1384,  -724,   -99,  1629,
    -724,  -724,  -724,  -724,  -724,  -724,  -724,  -724,  1017,  1018,
    1020,  1022,  1014,  1024,  1023,  1040,  -724,   -53,  -724,   -41,
    1041,   624,  1173,   600,   618,   598,   627,    95,  1034,   164,
    1044,  -724,  -724,   796,  -724,  -724,   203,  -724,  -724,  1384,
    -724,  1384,  -724,  1013,  -724,  1408,  -724,  1724,  1724,  1724,
    1724,  1030,  1724,  -724,  -724,  -724,  -724,  -724,    93,  -724,
    -724,  1046,  1047,  -118,  -724,  -724,  1042,  -724,   369,  -724,
    1052,  -724,   629,  -724,   880,   907,  1248,  1248,  1048,  -724,
    -724,  -724,  -724,  -724,  -724,  -724,  -724,   514,   -47,  -724,
     578,   475,  -724,  -724,  -724,  -724,  1049,  -724,  1053,  -724,
    -724,   511,  1503,  1051,  1417,  -137,  -724,  -724,  -724,  -724,
    -724,  1056,  -724,  -724,   277,   806,  -724,   806,  -724,  -724,
    -724,  -724,  -724,   825,  -724,  1184,  1384,  1384,  1384,  1384,
    1384,  1384,  1384,  1384,  1384,  1384,   916,  1064,  1098,  1129,
    1054,  1158,  -724,  -724,  -724,  -724,  1055,   492,  -724,  1188,
    -724,  -724,  -724,  -724,  -724,  1065,  -724,  -724,  -724,  -724,
    -724,  -724,  -724,  1068,  1071,  -724,  -724,  -724,  -724,   224,
    1670,  1210,  -724,  1209,  1067,  1066,  -724,  1444,  1078,  -724,
    -724,  -724,  -724,  -724,  -724,    32,  1075,   651,   663,  1089,
    -724,   260,   274,   485,  -724,  -724,  -724,  -724,   743,   743,
     743,   743,   743,  -724,  -724,  -724,  -724,  -724,  -724,  -724,
    -724,  -724,  1724,  -724,   492,  1081,  1101,  -724,  -724,  -724,
    -724,   530,  -724,  1187,  1503,   801,  1091,    85,  -724,  1248,
    -724,  -724,   527,  -724,  -724,  -724,  -724,  1417,  -724,  -724,
    -724,  -724,  -724,  1104,  -724,  1103,  1355,  1097,   184,   401,
    -724,  -724,  -724,  -724,  -724,  -724,  1087,  1090,  -724,  1092,
    -724,  -724,   646,  -724,  -724,  -724,  -724,  1112,  1114,  -724,
     184,  1107,  1088,  1117,  1697,  1697,  1697,  1417,  -724,  -724,
    1115,  1119,  1126,  1099,   121,   498,   563,  1264,  1127,  1130,
    1105,  1128,  1417,  1133,  -724,  1135,  1108,  -724,  -724,  1140,
    1139,  1273,  1146,  1143,  1277,  1116,  1145,  -724,  1118,  -724
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    26,     0,     0,     4,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     6,     7,   263,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   106,
       0,   108,     0,   110,     0,   112,     0,   114,     0,   116,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   265,   264,     0,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   246,     0,   248,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     1,     5,
       3,     0,     9,     0,    11,     0,    13,     0,    15,     0,
      17,     0,    19,     0,    21,     0,    23,     0,    25,   213,
     210,   214,   211,   215,   212,   217,   216,   209,   208,    92,
      91,    88,    87,    90,    89,     0,     0,    38,    84,    86,
      85,    94,    93,    96,    95,    98,    97,   100,    99,   221,
       0,    35,     0,    66,    65,   220,   219,   218,     0,   225,
      32,    28,   272,   271,     0,     0,    47,    29,     0,    51,
      52,   224,    27,   269,   273,   270,   227,   226,   102,   101,
     104,   103,   105,   107,   109,   111,   113,   115,   118,   117,
     123,   121,   127,   126,   129,   128,   131,   130,   133,   132,
     135,   134,   137,   136,   139,   138,   141,   140,   143,   142,
     145,   144,   147,   146,   149,   148,   151,   150,   153,   152,
     155,   154,   157,   156,   159,   158,   161,   160,   203,   202,
     205,   204,   207,   206,   244,   243,     0,   120,   119,   164,
     163,   162,   167,   166,   165,   169,   168,   172,   170,   171,
     174,   173,   177,   175,   179,   178,   181,   180,   183,   182,
     185,   184,   187,   186,   189,   188,   191,   190,   197,   196,
     199,   198,   201,   200,   193,   192,   195,   194,   229,    32,
     228,   231,   230,   233,   232,   235,   234,   237,   236,   239,
     238,   242,   240,   241,   245,   247,     0,   250,   252,   251,
     254,   253,   256,   255,   258,   257,   260,     0,   259,   262,
     261,   124,   286,     0,     0,   288,     0,   291,     0,     0,
     293,     0,   295,     0,   297,     0,   299,     0,   301,     0,
     303,     0,    39,    40,    44,     0,     0,     0,     0,     0,
       0,    31,     0,     0,     0,    53,     0,     0,     0,     0,
       0,     0,   439,     0,   441,   448,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   323,   387,
     324,     0,     0,     0,   376,   382,   383,   384,   385,     0,
     280,   279,   281,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    41,     0,     0,     0,     0,    57,
      58,    63,    70,    68,   223,    73,   222,   274,    48,    34,
      33,   122,     0,   176,     0,     0,   125,     0,     0,     0,
       0,   445,   443,   451,     0,   454,     0,   458,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   463,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     386,   377,   284,   375,   388,   381,     0,     0,   289,     0,
       0,   294,   296,   298,     0,     0,     0,     0,    61,    54,
      60,    59,    62,    64,    74,     0,     0,     0,     0,    78,
       0,     0,   440,     0,     0,     0,     0,   327,     0,   328,
     309,   325,   366,   326,   365,   364,   442,   447,     0,     0,
       0,     0,     0,     0,     0,     0,   282,     0,   283,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   460,   415,   417,   420,   423,     0,   362,   363,     0,
     345,     0,   344,   346,   347,   361,   348,     0,     0,     0,
       0,     0,     0,    36,    37,    46,    43,    42,     0,    50,
      49,     0,     0,     0,    71,    72,     0,    79,     0,   249,
       0,   306,     0,   368,     0,     0,     0,     0,     0,   310,
     312,   313,   314,   315,   311,   316,   317,   318,   319,   322,
       0,     0,   446,   444,   452,   449,     0,   455,     0,   459,
     456,     0,     0,     0,     0,     0,   464,   277,   465,   278,
     466,     0,   467,   437,     0,     0,   474,     0,   462,   418,
     421,   424,   461,   419,   359,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    56,    55,   266,   267,     0,     0,    77,     0,
     307,   367,   308,   305,   304,     0,   332,   275,   276,   333,
     331,   330,   329,     0,     0,   428,   426,   427,   429,     0,
       0,   400,   372,     0,     0,     0,   396,     0,     0,   402,
     369,   391,   392,   393,   394,     0,     0,     0,     0,     0,
     434,     0,     0,     0,   416,   422,   425,   360,   355,   354,
     356,   357,   358,   349,   350,   352,   351,   353,   285,   287,
     290,   292,     0,   302,     0,     0,     0,   438,   450,   453,
     457,     0,   374,     0,     0,     0,     0,   406,   408,     0,
     389,   371,     0,   379,   395,   397,   390,     0,   468,   469,
     436,   435,   470,     0,   473,     0,     0,     0,     0,     0,
     433,   430,   431,   432,   373,   401,     0,     0,   404,     0,
     407,   405,     0,   380,   370,   378,   403,     0,     0,   300,
       0,     0,    83,     0,   412,   410,   414,     0,   471,   472,
       0,     0,     0,    82,     0,     0,     0,   398,     0,     0,
       0,     0,     0,     0,    75,     0,     0,   399,    76,     0,
       0,     0,     0,     0,     0,     0,     0,    81,     0,    80
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -724,  -724,  -724,  1211,  -724,  -724,  -724,  -724,  -724,  -724,
    -724,  -724,  -724,  -168,  -724,  -724,  -124,  -569,  -116,   -64,
    -724,  -724,  1029,  -724,  -724,  -413,  1189,  -724,  -724,   647,
     799,   643,  -724,  -724,  -724,  -724,   -43,  -724,  1043,  -724,
    -723,  -421,  -321,  -724,  -724,  -724,  -724,  -724,  -724,  -724,
    -724,  -724,  -724,  -529,  -724,  -724,  -724,  -724,  -724,  -462,
    -724,  -510,  -724,   296,  -501,  -724,  -191,   491,  -426,   -42,
    -444,   -70,  -724,  -482,  -552,  -429,  -395,  -724,  -724,   489,
    -724,   605,  -724,   775,  -522
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   276,   453,   277,   262,   655,   642,   263,
     264,   280,   281,   580,   511,   512,   265,   447,   446,   666,
     516,   589,   590,   418,   105,   106,   282,   283,   284,   285,
     759,   624,   493,   617,   212,   214,   216,   218,   220,   222,
     224,   226,   228,   598,   687,   688,   689,   690,   691,   481,
     600,   644,   559,   645,   482,   603,   779,   771,   483,   832,
     484,   780,   781,   485,   486,   487,   488,   826,   827,   828,
     861,   636,   769,   628,   489
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     248,   278,   495,   532,   615,   656,   605,   498,   657,   499,
     619,   500,   621,   659,   349,   229,   660,   605,   601,   605,
     390,   269,   422,   564,   815,   478,   164,   602,   427,   601,
     425,   601,   430,   835,   513,   319,   321,   646,   602,   563,
     602,   107,   261,   451,   676,   677,   604,   480,   438,   440,
     108,   563,   432,   109,   563,   563,   563,   604,   110,   604,
     434,   279,   667,   664,   671,   672,   599,   678,   609,   167,
     452,   605,   605,   533,   646,   388,   618,   599,   620,   599,
     622,   436,   208,   601,   601,   111,   635,   535,   352,   743,
     537,   847,   602,   602,   742,   547,   713,   643,   583,   231,
     357,   112,   676,   677,   700,   494,   825,   859,   496,   113,
     497,   604,   604,   701,  -321,  -321,   702,   646,   501,   646,
     502,   114,   863,   626,   462,   463,   464,   465,   466,   467,
     468,   599,   599,   115,   643,   116,   249,  -321,   257,   774,
     255,   470,  -411,  -411,   775,   471,   472,   753,   754,   473,
     474,   310,   782,   314,   605,   605,   278,   340,   342,   117,
     344,   490,   653,   491,   492,   478,   601,   601,   372,   674,
     653,   721,   230,   350,   351,   602,   602,   643,   260,   643,
     270,   271,   785,   272,   273,   654,   165,   480,   233,   565,
     423,   274,   424,   654,   604,   604,   428,   408,   429,   836,
     426,   275,   431,   778,   646,   646,   646,   646,   646,   646,
     646,   646,   646,   646,   599,   599,   279,   616,   439,   441,
     433,   736,   737,   738,   739,   782,   741,   668,   435,   762,
     563,   669,   410,   514,   389,   271,   168,   272,   273,   768,
     534,   475,   476,   786,   613,   274,   374,   353,   354,   437,
     630,   653,   635,   129,   536,   785,   232,   538,   772,   358,
     359,   796,   548,   714,   643,   643,   643,   643,   643,   643,
     643,   643,   643,   643,   654,   783,   778,   504,   789,   871,
     782,   477,   518,   478,   235,   782,   504,   237,   776,   131,
     788,  -411,   563,   563,   563,   563,   250,   563,   258,   256,
     862,   880,   610,   239,   118,   480,   133,   605,   259,   784,
     785,   311,   266,   315,   119,   785,   401,   341,   343,   601,
     345,   716,   782,   782,   782,   782,   416,   373,   602,   519,
     717,   778,   782,   782,   782,   120,   778,   318,   579,   241,
     782,   243,   653,   320,   823,   234,   121,   604,   783,   531,
     135,   251,   785,   785,   785,   785,   253,   409,   286,   853,
     722,   122,   785,   785,   785,   654,   123,   599,   288,   723,
     785,   124,   290,   778,   778,   778,   778,   130,   125,   563,
     772,   820,   784,   778,   778,   778,   846,   298,   137,   300,
     821,   778,   411,   515,   792,   126,   793,   302,   127,   245,
     246,   304,   563,   783,   614,   375,   631,   247,   783,   128,
     632,   478,   597,   132,   608,   633,   306,   841,   612,   308,
     312,   316,   322,   597,   139,   597,   723,   245,   246,   141,
     134,   842,   634,   480,   790,   247,   324,   784,   632,   478,
     843,   236,   784,   633,   238,   783,   783,   783,   783,   326,
     211,   245,   246,   328,   330,   783,   783,   783,   332,   247,
     240,   480,   611,   783,   665,   260,   334,   261,   142,   260,
     662,   261,   143,   402,   136,   403,   144,   597,   597,   784,
     784,   784,   784,   336,   338,   417,   245,   246,   -30,   784,
     784,   784,   245,   246,   247,   347,   242,   784,   244,   863,
     247,   462,   463,   464,   465,   466,   467,   468,   252,   355,
     360,   195,   138,   254,   362,   287,   774,   720,   470,  -409,
    -409,   775,   471,   472,   587,   289,   473,   474,   863,   291,
     462,   463,   464,   465,   466,   467,   468,   588,   765,   665,
     197,   756,   364,   366,   299,   774,   301,   470,   140,   368,
     775,   471,   472,   370,   303,   473,   474,   850,   305,   145,
     597,   597,   376,   378,   863,   380,   462,   463,   464,   465,
     466,   467,   468,   307,   760,   382,   309,   313,   317,   323,
     384,   774,   386,   470,   391,   767,   775,   471,   472,   872,
     873,   473,   474,   325,   393,   395,   397,   561,   634,   462,
     463,   464,   465,   466,   467,   468,   327,   795,   399,   146,
     329,   331,   412,   414,   469,   333,   470,   419,   475,   476,
     471,   472,   147,   335,   473,   474,   561,   148,   462,   463,
     464,   465,   466,   467,   468,   196,   761,   478,   213,   219,
     337,   339,   844,   469,   758,   470,   866,   475,   476,   471,
     472,   845,   348,   473,   474,   272,   273,   757,   477,   480,
     478,   245,   246,   274,   198,   776,   356,   361,  -409,   247,
     149,   363,   766,   478,   150,  -320,  -320,   272,   273,   757,
     245,   246,   480,   475,   476,   274,   887,   477,   247,   478,
     151,   851,   478,   152,   776,   480,   153,   864,  -320,   365,
     367,   897,   154,   215,   758,   852,   369,   833,   217,   857,
     371,   480,   -69,   597,   480,   155,   475,   476,   221,   377,
     379,   223,   381,   477,   156,   478,   245,   246,   245,   246,
     776,   157,   383,  -413,   247,   158,   247,   385,   478,   387,
     -67,   392,   245,   246,   530,   475,   476,   480,   159,   607,
     247,   394,   396,   398,   478,   710,   477,   706,   478,   707,
     480,   707,   865,   479,   711,   400,   562,   676,   677,   413,
     415,   758,   676,   677,   420,   708,   480,   160,   505,   709,
     480,   704,   161,   162,   712,   477,   750,   478,   709,   676,
     677,   163,   479,   166,   561,   568,   462,   463,   464,   465,
     466,   467,   468,   877,   833,   833,   833,   169,   838,   480,
     170,   469,   707,   470,   865,   865,   865,   471,   472,   171,
     839,   473,   474,   561,   709,   462,   463,   464,   465,   466,
     467,   468,   884,   885,   886,   -69,   -69,   -69,   172,   173,
     469,   227,   470,   174,   -69,   -69,   471,   472,   175,   176,
     473,   474,   561,   225,   462,   463,   464,   465,   466,   467,
     468,   177,   178,   -67,   -67,   -67,   245,   246,   268,   469,
     179,   470,   -67,   -67,   247,   471,   472,   661,   180,   473,
     474,   561,   181,   462,   463,   464,   465,   466,   467,   468,
     182,   183,   675,   731,   732,   733,   734,   735,   469,   184,
     470,   506,   507,   508,   471,   472,   185,   186,   473,   474,
     509,   510,   187,   475,   476,   188,   189,   561,   292,   462,
     463,   464,   465,   466,   467,   468,   260,   190,   270,   271,
     191,   272,   273,   192,   469,   724,   470,   725,   193,   274,
     471,   472,   475,   476,   473,   474,   245,   246,   194,   275,
     293,   245,   246,   477,   247,   478,   199,   719,   478,   247,
     479,   200,   856,   571,   490,   201,   491,   492,   202,   294,
     203,   475,   476,   204,   205,   245,   246,   480,   206,   207,
     480,   346,   477,   247,   478,   295,   794,   478,   296,   479,
     297,   404,   572,   405,   406,   444,   407,   503,   445,   421,
     475,   476,   460,   456,   389,   271,   480,   272,   273,   480,
     442,   477,   457,   478,   443,   274,   522,   458,   479,   448,
     272,   573,   798,   799,   800,   801,   802,   803,   804,   805,
     806,   807,   517,   520,   521,   480,   475,   476,   -35,   450,
     477,   454,   478,   459,   461,   523,   524,   479,   525,   526,
     751,   527,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   528,   529,   480,   561,   539,   462,   463,   464,
     465,   466,   467,   468,   540,   560,   477,   541,   478,   752,
     542,   543,   469,   479,   470,   544,   808,   545,   471,   472,
     546,   576,   473,   474,   574,   566,   567,   569,   570,   561,
     480,   462,   463,   464,   465,   466,   467,   468,   389,   271,
     575,   272,   273,   577,   578,   581,   469,   515,   470,   274,
     582,   585,   471,   472,   586,   592,   473,   474,   606,   591,
     561,   623,   462,   463,   464,   465,   466,   467,   468,   679,
     680,   681,   682,   683,   684,   685,   686,   469,   625,   470,
     627,   637,   638,   471,   472,   647,   651,   473,   474,   561,
     648,   462,   463,   464,   465,   466,   467,   468,   649,   650,
     652,   663,   658,   670,   692,   693,   469,   694,   470,   695,
     696,   697,   471,   472,   475,   476,   473,   474,   561,   698,
     462,   463,   464,   465,   466,   467,   468,   699,   703,   705,
     715,   718,   740,   744,   745,   469,   749,   470,   747,   755,
     763,   471,   472,   816,   764,   473,   474,   787,   475,   476,
     773,   814,   817,   812,   477,   818,   478,   549,   819,   824,
     825,   479,   837,   830,   809,   829,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   834,   840,   848,   480,   475,
     476,   462,   463,   464,   465,   466,   467,   468,   477,   849,
     478,   858,   867,   870,   868,   479,   469,   874,   810,   878,
     875,   879,   876,   881,   882,   883,   473,   474,   475,   476,
     889,   888,   480,   892,   890,   891,   896,   894,   893,   477,
     898,   478,   895,   899,   901,   900,   479,   902,   903,   811,
     904,   905,   906,   908,   907,   210,   909,   475,   476,   455,
     746,   748,   267,   480,   584,   855,   860,   449,   477,   791,
     478,   629,     0,     0,     0,   479,     0,     0,   813,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,     0,
       0,   797,   480,     0,     0,     0,     0,   477,     0,   478,
       0,     0,     0,     0,   479,     0,   561,   854,   462,   463,
     464,   465,   466,   467,   468,     0,     0,     0,   475,   476,
       0,   480,     0,   469,     0,   470,     0,     0,     0,   471,
     472,     0,     0,   473,   474,     0,     0,   462,   463,   464,
     465,   466,   467,   468,     0,     0,     0,     0,   245,   246,
       0,     0,     0,   593,     0,     0,   247,     0,   477,     0,
     478,     0,   473,   474,     0,     0,   594,   595,     0,   596,
     462,   463,   464,   465,   466,   467,   468,     0,     0,     0,
       0,     0,   480,     0,     0,   774,     0,   470,     0,     0,
     775,   471,   472,     0,     0,   473,   474,   462,   463,   464,
     465,   466,   467,   468,     0,     0,     0,     0,     0,     0,
       0,     0,   774,     0,   470,     0,     0,   775,   471,   472,
       0,     0,   473,   474,     0,   475,   476,   462,   463,   464,
     465,   466,   467,   468,     0,     0,     0,     0,     0,     0,
       0,     0,   469,     0,   470,     0,     0,     0,   471,   472,
       0,     0,   473,   474,   475,   476,   462,   463,   464,   465,
     466,   467,   468,     0,     0,   477,     0,   478,     0,     0,
       0,   469,   479,   470,     0,   869,     0,   471,   472,     0,
       0,   473,   474,     0,   245,   246,     0,   475,   476,   480,
     639,     0,   247,     0,   477,   640,   478,     0,     0,     0,
       0,     0,   641,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,     0,   475,   476,     0,     0,   480,     0,
       0,     0,     0,     0,     0,     0,     0,   477,     0,   478,
       0,     0,     0,     0,   776,     0,   777,     0,     0,     0,
       0,     0,     0,     0,   475,   476,     0,     0,     0,     0,
       0,   480,     0,     0,   477,     0,   478,     0,     0,     0,
       0,   776,     0,     0,   831,     0,     0,     0,     0,     0,
       0,     0,     0,   475,   476,     0,     0,     0,   480,     0,
       0,     0,     0,     0,   477,     0,   478,     0,     0,     0,
       0,   479,     0,     0,   673,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   480,     0,
       0,     0,     0,   477,     0,   478,     0,     0,     0,     0,
     479,     0,   770,   462,   463,   464,   465,   466,   467,   468,
       0,     0,     0,     0,     0,     0,     0,   480,   469,     0,
     470,     0,     0,     0,   471,   472,     0,     0,   473,   474,
     462,   463,   464,   465,   466,   467,   468,     0,     0,     0,
       0,     0,     0,     0,     0,   774,     0,   470,     0,     0,
     775,   471,   472,     0,     0,   473,   474,   462,   463,   464,
     465,   466,   467,   468,     0,     0,     0,     0,     0,     0,
       0,     0,   469,     0,   470,     0,     0,     0,   471,   472,
       0,     0,   473,   474,   549,   679,   680,   681,   682,   683,
     684,   685,   686,   550,   551,   552,   553,   554,   555,   556,
     557,   558,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     475,   476,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   475,   476,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     477,     0,   478,     0,     0,     0,     0,   479,     0,     0,
     822,     0,     0,     0,   475,   476,     0,     0,     0,     0,
       0,     0,     0,     0,   480,     0,     0,   477,     0,   478,
       0,     0,     0,     0,   776,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   480,     0,     0,   477,     0,   478,    -2,   209,     0,
       0,   479,     0,     0,     0,     0,    -8,   -10,   -12,   -14,
     -16,   -18,   -20,   -22,   -24,     0,     0,     0,   480,     0,
       0,     0,     0,     0,     0,     0,     0,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,     0,    16,    17,    18,    19,    20,     0,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,     0,     0,     0,    89,
      90,    91,     0,     0,     0,     0,     0,     1,     0,     0,
       0,     0,     0,     0,     0,    -8,   -10,   -12,   -14,   -16,
     -18,   -20,   -22,   -24,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     2,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
       0,    16,    17,    18,    19,    20,    92,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,     0,     0,     0,    89,    90,
      91,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    92
};

static const yytype_int16 yycheck[] =
{
     116,   125,   428,   465,     1,     1,   528,   433,   577,   435,
     539,   437,   541,     1,     1,     1,   585,   539,   528,   541,
     188,     1,     1,     1,   747,   162,     1,   528,     1,   539,
       1,   541,     1,     1,   447,   151,   152,   559,   539,   483,
     541,   125,   160,   151,   143,   144,   528,   184,     1,     1,
     125,   495,     1,   125,   498,   499,   500,   539,   125,   541,
       1,   125,     1,   181,   593,   594,   528,   166,   530,     1,
     178,   593,   594,     1,   596,     1,   538,   539,   540,   541,
     542,     1,     0,   593,   594,   125,   548,     1,     1,   658,
       1,   814,   593,   594,     1,     1,     1,   559,   511,     1,
       1,   125,   143,   144,   157,   426,    21,    22,   429,   125,
     431,   593,   594,   166,   161,   162,   157,   639,   439,   641,
     441,   125,     1,   544,     3,     4,     5,     6,     7,     8,
       9,   593,   594,   125,   596,   125,     1,   184,     1,    18,
       1,    20,    21,    22,    23,    24,    25,   676,   677,    28,
      29,     1,   704,     1,   676,   677,   280,     1,     1,   125,
       1,   158,   158,   160,   161,   162,   676,   677,     1,   595,
     158,   633,   158,   160,   161,   676,   677,   639,   158,   641,
     160,   161,   704,   163,   164,   181,   161,   184,     1,   167,
     169,   171,   171,   181,   676,   677,   169,     1,   171,   167,
     171,   181,   171,   704,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   676,   677,   280,   538,   171,   171,
     169,   647,   648,   649,   650,   777,   652,   166,   169,   691,
     674,   170,     1,     1,   160,   161,   168,   163,   164,   701,
     168,   120,   121,   705,     1,   171,     1,   160,   161,   169,
       1,   158,   714,     1,   168,   777,   158,   168,   702,   160,
     161,   723,   168,   168,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   181,   704,   777,   445,     1,   848,
     832,   160,   450,   162,     1,   837,   454,     1,   167,     1,
     711,   170,   736,   737,   738,   739,   161,   741,   161,   160,
     829,   870,     1,     1,   125,   184,     1,   829,     1,   704,
     832,   161,     1,   161,   125,   837,     1,   161,   161,   829,
     161,   157,   874,   875,   876,   877,     1,   160,   829,     1,
     166,   832,   884,   885,   886,   125,   837,     1,   506,     1,
     892,     1,   158,     1,   770,   158,   125,   829,   777,   465,
       1,     1,   874,   875,   876,   877,     1,   161,     1,   821,
     157,   125,   884,   885,   886,   181,   125,   829,     1,   166,
     892,   125,     1,   874,   875,   876,   877,   125,   125,   823,
     824,   157,   777,   884,   885,   886,   812,     1,     1,     1,
     166,   892,   161,   161,   715,   125,   717,     1,   125,   150,
     151,     1,   846,   832,   161,   160,   157,   158,   837,   125,
     161,   162,   528,   125,   530,   166,     1,   157,   534,     1,
       1,     1,     1,   539,     1,   541,   166,   150,   151,   125,
     125,   157,   548,   184,   157,   158,     1,   832,   161,   162,
     166,   158,   837,   166,   158,   874,   875,   876,   877,     1,
       9,   150,   151,     1,     1,   884,   885,   886,     1,   158,
     158,   184,   161,   892,   588,   158,     1,   160,   125,   158,
     586,   160,   125,   158,   125,   160,   125,   593,   594,   874,
     875,   876,   877,     1,     1,   160,   150,   151,   160,   884,
     885,   886,   150,   151,   158,     1,   158,   892,   158,     1,
     158,     3,     4,     5,     6,     7,     8,     9,   158,     1,
       1,     1,   125,   158,     1,   158,    18,   633,    20,    21,
      22,    23,    24,    25,   155,   158,    28,    29,     1,   158,
       3,     4,     5,     6,     7,     8,     9,   168,    27,   663,
       1,    27,     1,     1,   158,    18,   158,    20,   125,     1,
      23,    24,    25,     1,   158,    28,    29,    27,   158,   125,
     676,   677,     1,     1,     1,     1,     3,     4,     5,     6,
       7,     8,     9,   158,   690,     1,   158,   158,   158,   158,
       1,    18,     1,    20,     1,   701,    23,    24,    25,   188,
     189,    28,    29,   158,     1,     1,     1,     1,   714,     3,
       4,     5,     6,     7,     8,     9,   158,   723,     1,   125,
     158,   158,     1,     1,    18,   158,    20,     1,   120,   121,
      24,    25,   125,   158,    28,    29,     1,   125,     3,     4,
       5,     6,     7,     8,     9,   125,   161,   162,    10,    13,
     158,   158,   157,    18,   687,    20,   837,   120,   121,    24,
      25,   166,   158,    28,    29,   163,   164,   165,   160,   184,
     162,   150,   151,   171,   125,   167,   158,   158,   170,   158,
     125,   158,   161,   162,   125,   161,   162,   163,   164,   165,
     150,   151,   184,   120,   121,   171,   877,   160,   158,   162,
     125,   161,   162,   125,   167,   184,   125,   170,   184,   158,
     158,   892,   125,    11,   747,   821,   158,   777,    12,   825,
     158,   184,    50,   829,   184,   125,   120,   121,    14,   158,
     158,    15,   158,   160,   125,   162,   150,   151,   150,   151,
     167,   125,   158,   170,   158,   125,   158,   158,   162,   158,
      50,   158,   150,   151,   168,   120,   121,   184,   125,   157,
     158,   158,   158,   158,   162,   157,   160,   157,   162,   161,
     184,   161,   832,   167,   166,   158,   170,   143,   144,   158,
     158,   814,   143,   144,   158,   157,   184,   125,    50,   161,
     184,   157,   125,   125,   157,   160,   157,   162,   161,   143,
     144,   125,   167,   125,     1,   170,     3,     4,     5,     6,
       7,     8,     9,   157,   874,   875,   876,   125,   157,   184,
     125,    18,   161,    20,   884,   885,   886,    24,    25,   125,
     157,    28,    29,     1,   161,     3,     4,     5,     6,     7,
       8,     9,   874,   875,   876,   173,   174,   175,   125,   125,
      18,    17,    20,   125,   182,   183,    24,    25,   125,   125,
      28,    29,     1,    16,     3,     4,     5,     6,     7,     8,
       9,   125,   125,   173,   174,   175,   150,   151,   161,    18,
     125,    20,   182,   183,   158,    24,    25,   161,   125,    28,
      29,     1,   125,     3,     4,     5,     6,     7,     8,     9,
     125,   125,   596,   150,   151,   152,   153,   154,    18,   125,
      20,   173,   174,   175,    24,    25,   125,   125,    28,    29,
     182,   183,   125,   120,   121,   125,   125,     1,   158,     3,
       4,     5,     6,     7,     8,     9,   158,   125,   160,   161,
     125,   163,   164,   125,    18,   639,    20,   641,   125,   171,
      24,    25,   120,   121,    28,    29,   150,   151,   125,   181,
     158,   150,   151,   160,   158,   162,   125,   161,   162,   158,
     167,   125,   161,   170,   158,   125,   160,   161,   125,   158,
     125,   120,   121,   125,   125,   150,   151,   184,   125,   125,
     184,   161,   160,   158,   162,   158,   161,   162,   158,   167,
     158,   158,   170,   158,   160,     1,   158,   153,   180,   158,
     120,   121,   185,   175,   160,   161,   184,   163,   164,   184,
     158,   160,   166,   162,   158,   171,   161,   175,   167,   180,
     163,   170,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   172,   160,   160,   184,   120,   121,   180,   180,
     160,   180,   162,   180,   175,   160,   169,   167,   158,   160,
     170,   168,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   168,   168,   184,     1,   168,     3,     4,     5,
       6,     7,     8,     9,   168,   167,   160,   168,   162,   172,
     168,   168,    18,   167,    20,   168,   170,   168,    24,    25,
     168,   180,    28,    29,   166,   172,   172,   172,   172,     1,
     184,     3,     4,     5,     6,     7,     8,     9,   160,   161,
     172,   163,   164,   180,   160,   158,    18,   161,    20,   171,
     160,   180,    24,    25,   166,   157,    28,    29,   157,   187,
       1,   161,     3,     4,     5,     6,     7,     8,     9,   126,
     127,   128,   129,   130,   131,   132,   133,    18,   161,    20,
     160,    27,    27,    24,    25,   169,   158,    28,    29,     1,
     169,     3,     4,     5,     6,     7,     8,     9,   169,   169,
     169,   168,   180,   158,   157,   157,    18,   157,    20,   157,
     166,   157,    24,    25,   120,   121,    28,    29,     1,   166,
       3,     4,     5,     6,     7,     8,     9,   157,   157,    26,
     166,   157,   172,   157,   157,    18,   154,    20,   166,   161,
     161,    24,    25,    25,   161,    28,    29,   161,   120,   121,
     169,   166,   157,   169,   160,   157,   162,   125,   157,    19,
      21,   167,   157,   167,   170,   168,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   167,   157,   166,   184,   120,
     121,     3,     4,     5,     6,     7,     8,     9,   160,   158,
     162,   170,   158,   166,   161,   167,    18,   180,   170,   157,
     180,   157,   180,   166,   186,   158,    28,    29,   120,   121,
     161,   166,   184,    19,   158,   186,   158,   157,   161,   160,
     157,   162,   187,   158,   154,   187,   167,   158,    25,   170,
     154,   158,    25,   158,   188,    94,   188,   120,   121,   280,
     663,   668,   123,   184,   515,   824,   827,   274,   160,   714,
     162,   546,    -1,    -1,    -1,   167,    -1,    -1,   170,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,    -1,
      -1,   157,   184,    -1,    -1,    -1,    -1,   160,    -1,   162,
      -1,    -1,    -1,    -1,   167,    -1,     1,   170,     3,     4,
       5,     6,     7,     8,     9,    -1,    -1,    -1,   120,   121,
      -1,   184,    -1,    18,    -1,    20,    -1,    -1,    -1,    24,
      25,    -1,    -1,    28,    29,    -1,    -1,     3,     4,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,   150,   151,
      -1,    -1,    -1,   155,    -1,    -1,   158,    -1,   160,    -1,
     162,    -1,    28,    29,    -1,    -1,   168,   169,    -1,   171,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    -1,   184,    -1,    -1,    18,    -1,    20,    -1,    -1,
      23,    24,    25,    -1,    -1,    28,    29,     3,     4,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    -1,    20,    -1,    -1,    23,    24,    25,
      -1,    -1,    28,    29,    -1,   120,   121,     3,     4,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    -1,    20,    -1,    -1,    -1,    24,    25,
      -1,    -1,    28,    29,   120,   121,     3,     4,     5,     6,
       7,     8,     9,    -1,    -1,   160,    -1,   162,    -1,    -1,
      -1,    18,   167,    20,    -1,   170,    -1,    24,    25,    -1,
      -1,    28,    29,    -1,   150,   151,    -1,   120,   121,   184,
     156,    -1,   158,    -1,   160,   161,   162,    -1,    -1,    -1,
      -1,    -1,   168,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   120,   121,    -1,    -1,   184,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   160,    -1,   162,
      -1,    -1,    -1,    -1,   167,    -1,   169,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,   121,    -1,    -1,    -1,    -1,
      -1,   184,    -1,    -1,   160,    -1,   162,    -1,    -1,    -1,
      -1,   167,    -1,    -1,   170,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   120,   121,    -1,    -1,    -1,   184,    -1,
      -1,    -1,    -1,    -1,   160,    -1,   162,    -1,    -1,    -1,
      -1,   167,    -1,    -1,   170,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   184,    -1,
      -1,    -1,    -1,   160,    -1,   162,    -1,    -1,    -1,    -1,
     167,    -1,   169,     3,     4,     5,     6,     7,     8,     9,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   184,    18,    -1,
      20,    -1,    -1,    -1,    24,    25,    -1,    -1,    28,    29,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    -1,    20,    -1,    -1,
      23,    24,    25,    -1,    -1,    28,    29,     3,     4,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    -1,    20,    -1,    -1,    -1,    24,    25,
      -1,    -1,    28,    29,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     120,   121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,   121,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     160,    -1,   162,    -1,    -1,    -1,    -1,   167,    -1,    -1,
     170,    -1,    -1,    -1,   120,   121,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   184,    -1,    -1,   160,    -1,   162,
      -1,    -1,    -1,    -1,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   184,    -1,    -1,   160,    -1,   162,     0,     1,    -1,
      -1,   167,    -1,    -1,    -1,    -1,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    -1,    -1,    -1,   184,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    -1,    45,    46,    47,    48,    49,    -1,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,    -1,    -1,   122,
     123,   124,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      -1,    45,    46,    47,    48,    49,   179,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,    -1,    -1,   122,   123,
     124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   179
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    45,    46,    47,    48,
      49,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   122,
     123,   124,   179,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   225,   226,   125,   125,   125,
     125,   125,   125,   125,   125,   125,   125,   125,   125,   125,
     125,   125,   125,   125,   125,   125,   125,   125,   125,     1,
     125,     1,   125,     1,   125,     1,   125,     1,   125,     1,
     125,   125,   125,   125,   125,   125,   125,   125,   125,   125,
     125,   125,   125,   125,   125,   125,   125,   125,   125,   125,
     125,   125,   125,   125,     1,   161,   125,     1,   168,   125,
     125,   125,   125,   125,   125,   125,   125,   125,   125,   125,
     125,   125,   125,   125,   125,   125,   125,   125,   125,   125,
     125,   125,   125,   125,   125,     1,   125,     1,   125,   125,
     125,   125,   125,   125,   125,   125,   125,   125,     0,     1,
     194,     9,   235,    10,   236,    11,   237,    12,   238,    13,
     239,    14,   240,    15,   241,    16,   242,    17,   243,     1,
     158,     1,   158,     1,   158,     1,   158,     1,   158,     1,
     158,     1,   158,     1,   158,   150,   151,   158,   209,     1,
     161,     1,   158,     1,   158,     1,   160,     1,   161,     1,
     158,   160,   207,   210,   211,   217,     1,   217,   161,     1,
     160,   161,   163,   164,   171,   181,   204,   206,   207,   210,
     212,   213,   227,   228,   229,   230,     1,   158,     1,   158,
       1,   158,   158,   158,   158,   158,   158,   158,     1,   158,
       1,   158,     1,   158,     1,   158,     1,   158,     1,   158,
       1,   161,     1,   158,     1,   161,     1,   158,     1,   209,
       1,   209,     1,   158,     1,   158,     1,   158,     1,   158,
       1,   158,     1,   158,     1,   158,     1,   158,     1,   158,
       1,   161,     1,   161,     1,   161,   161,     1,   158,     1,
     160,   161,     1,   160,   161,     1,   158,     1,   160,   161,
       1,   158,     1,   158,     1,   158,     1,   158,     1,   158,
       1,   158,     1,   160,     1,   160,     1,   158,     1,   158,
       1,   158,     1,   158,     1,   158,     1,   158,     1,   160,
     204,     1,   158,     1,   158,     1,   158,     1,   158,     1,
     158,     1,   158,   160,   158,   158,   160,   158,     1,   161,
       1,   161,     1,   158,     1,   158,     1,   160,   224,     1,
     158,   158,     1,   169,   171,     1,   171,     1,   169,   171,
       1,   171,     1,   169,     1,   169,     1,   169,     1,   171,
       1,   171,   158,   158,     1,   180,   219,   218,   180,   229,
     180,   151,   178,   205,   180,   213,   175,   166,   175,   180,
     185,   175,     3,     4,     5,     6,     7,     8,     9,    18,
      20,    24,    25,    28,    29,   120,   121,   160,   162,   167,
     184,   250,   255,   259,   261,   264,   265,   266,   267,   275,
     158,   160,   161,   233,   233,   259,   233,   233,   259,   259,
     259,   233,   233,   153,   204,    50,   173,   174,   175,   182,
     183,   215,   216,   216,     1,   161,   221,   172,   204,     1,
     160,   160,   161,   160,   169,   158,   160,   168,   168,   168,
     168,   209,   250,     1,   168,     1,   168,     1,   168,   168,
     168,   168,   168,   168,   168,   168,   168,     1,   168,   125,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   253,
     167,     1,   170,   261,     1,   167,   172,   172,   170,   172,
     172,   170,   170,   170,   166,   172,   180,   180,   160,   204,
     214,   158,   160,   216,   221,   180,   166,   155,   168,   222,
     223,   187,   157,   155,   168,   169,   171,   209,   244,   250,
     251,   252,   255,   256,   264,   275,   157,   157,   209,   250,
       1,   161,   209,     1,   161,     1,   233,   234,   250,   244,
     250,   244,   250,   161,   232,   161,   232,   160,   274,   274,
       1,   157,   161,   166,   209,   250,   272,    27,    27,   156,
     161,   168,   209,   250,   252,   254,   275,   169,   169,   169,
     169,   158,   169,   158,   181,   208,     1,   208,   180,     1,
     208,   161,   209,   168,   181,   207,   220,     1,   166,   170,
     158,   244,   244,   170,   259,   254,   143,   144,   166,   126,
     127,   128,   129,   130,   131,   132,   133,   245,   246,   247,
     248,   249,   157,   157,   157,   157,   166,   157,   166,   157,
     157,   166,   157,   157,   157,    26,   157,   161,   157,   161,
     157,   166,   157,     1,   168,   166,   157,   166,   157,   161,
     209,   250,   157,   166,   254,   254,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   259,   259,   259,   259,
     172,   259,     1,   208,   157,   157,   220,   166,   222,   154,
     157,   170,   172,   244,   244,   161,    27,   165,   227,   231,
     209,   161,   250,   161,   161,    27,   161,   209,   250,   273,
     169,   258,   261,   169,    18,    23,   167,   169,   255,   257,
     262,   263,   265,   266,   267,   275,   250,   161,   232,     1,
     157,   272,   233,   233,   161,   209,   250,   157,   254,   254,
     254,   254,   254,   254,   254,   254,   254,   254,   170,   170,
     170,   170,   169,   170,   166,   231,    25,   157,   157,   157,
     157,   166,   170,   259,    19,    21,   268,   269,   270,   168,
     167,   170,   260,   262,   167,     1,   167,   157,   157,   157,
     157,   157,   157,   166,   157,   166,   259,   231,   166,   158,
      27,   161,   209,   250,   170,   258,   161,   209,   170,    22,
     270,   271,   244,     1,   170,   262,   257,   158,   161,   170,
     166,   208,   188,   189,   180,   180,   180,   157,   157,   157,
     208,   166,   186,   158,   260,   260,   260,   257,   166,   161,
     158,   186,    19,   161,   157,   187,   158,   257,   157,   158,
     187,   154,   158,    25,   154,   158,    25,   188,   158,   188
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   191,   192,   193,   193,   193,   194,   194,   195,   194,
     196,   194,   197,   194,   198,   194,   199,   194,   200,   194,
     201,   194,   202,   194,   203,   194,   194,   204,   204,   204,
     205,   205,   206,   206,   206,   207,   208,   208,   209,   209,
     209,   210,   210,   210,   210,   211,   211,   212,   212,   212,
     212,   212,   213,   213,   214,   214,   214,   215,   215,   215,
     215,   215,   215,   216,   216,   217,   217,   218,   217,   219,
     217,   220,   220,   221,   221,   222,   222,   223,   223,   223,
     224,   224,   224,   224,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   226,   226,   226,   226,   226,   227,
     227,   228,   229,   230,   230,   231,   231,   232,   232,   233,
     233,   233,   234,   234,   235,   235,   235,   236,   236,   237,
     237,   237,   238,   238,   239,   239,   240,   240,   241,   241,
     242,   242,   243,   243,   244,   244,   244,   244,   244,   244,
     245,   245,   246,   246,   246,   246,   247,   247,   248,   248,
     249,   249,   249,   250,   250,   251,   251,   251,   251,   252,
     252,   252,   252,   252,   253,   253,   253,   253,   253,   253,
     253,   253,   253,   253,   254,   254,   254,   254,   254,   254,
     254,   254,   254,   254,   254,   254,   254,   254,   254,   254,
     254,   255,   255,   255,   256,   256,   256,   256,   256,   257,
     257,   257,   258,   258,   258,   259,   259,   259,   260,   260,
     260,   261,   261,   261,   261,   261,   261,   261,   261,   262,
     262,   262,   262,   262,   262,   262,   262,   262,   263,   263,
     264,   264,   265,   266,   267,   268,   268,   269,   269,   270,
     270,   270,   270,   271,   271,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   273,   273,   273,   273,
     273,   273,   273,   273,   274,   274,   274,   274,   275,   275,
     275,   275,   275,   275,   275,   275,   275,   275,   275,   275,
     275,   275,   275,   275,   275,   275,   275,   275,   275,   275,
     275,   275,   275,   275,   275,   275,   275,   275,   275,   275,
     275,   275,   275,   275,   275
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     1,     1,     1,     1,     2,
       2,     3,     5,     5,     2,     3,     5,     1,     3,     5,
       5,     1,     1,     2,     1,     3,     3,     1,     1,     2,
       2,     2,     2,     1,     2,     1,     1,     0,     3,     0,
       3,     1,     1,     1,     2,     9,    10,     3,     1,     2,
      18,    17,    10,     9,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     3,     3,
       3,     3,     5,     3,     3,     5,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     5,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     5,     5,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     2,     7,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     2,     2,     8,     8,     2,     1,
       1,     1,     1,     1,     3,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     4,     7,     2,     7,     2,     4,
       7,     2,     7,     2,     4,     2,     4,     2,     4,     2,
       9,     2,     7,     2,     3,     3,     2,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     3,     3,     3,     1,     1,     1,     3,     2,     1,
       3,     2,     1,     3,     2,     2,     1,     2,     2,     1,
       2,     2,     1,     1,     1,     1,     2,     1,     2,     2,
       2,     1,     1,     1,     1,     2,     1,     2,     5,     7,
       5,     7,     5,     7,     7,     2,     1,     2,     1,     4,
       3,     4,     3,     3,     2,     1,     3,     1,     2,     2,
       1,     2,     3,     1,     2,     3,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     4,     4,     2,     6,     1,
       3,     1,     3,     2,     4,     2,     4,     3,     1,     4,
       6,     2,     4,     6,     2,     4,     4,     6,     2,     4,
       3,     4,     4,     2,     4,     4,     4,     4,     6,     6,
       6,     8,     8,     6,     4
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 486 "cfg.y" /* yacc.c:1646  */
    {}
#line 2501 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 487 "cfg.y" /* yacc.c:1646  */
    {}
#line 2507 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 488 "cfg.y" /* yacc.c:1646  */
    { yyerror(""); YYABORT;}
#line 2513 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 493 "cfg.y" /* yacc.c:1646  */
    {rt=REQUEST_ROUTE;}
#line 2519 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 494 "cfg.y" /* yacc.c:1646  */
    {rt=FAILURE_ROUTE;}
#line 2525 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 495 "cfg.y" /* yacc.c:1646  */
    {rt=ONREPLY_ROUTE;}
#line 2531 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 496 "cfg.y" /* yacc.c:1646  */
    {rt=BRANCH_ROUTE;}
#line 2537 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 497 "cfg.y" /* yacc.c:1646  */
    {rt=ERROR_ROUTE;}
#line 2543 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 498 "cfg.y" /* yacc.c:1646  */
    {rt=LOCAL_ROUTE;}
#line 2549 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 499 "cfg.y" /* yacc.c:1646  */
    {rt=STARTUP_ROUTE;}
#line 2555 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 500 "cfg.y" /* yacc.c:1646  */
    {rt=TIMER_ROUTE;}
#line 2561 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 501 "cfg.y" /* yacc.c:1646  */
    {rt=EVENT_ROUTE;}
#line 2567 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 506 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							tmp=ip_addr2a((yyvsp[0].ipaddr));
							if(tmp==0){
								LM_CRIT("cfg. parser: bad ip address.\n");
								(yyval.strval)=0;
							}else{
								(yyval.strval)=pkg_malloc(strlen(tmp)+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), tmp, strlen(tmp)+1);
								}
							}
						}
#line 2587 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 521 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
							if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
							}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
							}
						}
#line 2601 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 530 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							if ((yyvsp[0].strval)==0) {
								(yyval.strval) = 0;
							} else {
								(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
								}
							}
						}
#line 2619 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 545 "cfg.y" /* yacc.c:1646  */
    {(yyval.strval)=".";}
#line 2625 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 546 "cfg.y" /* yacc.c:1646  */
    {(yyval.strval)="-"; }
#line 2631 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 549 "cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 2637 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 550 "cfg.y" /* yacc.c:1646  */
    { IFOR();
						(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
						if ((yyval.strval)==0){
							LM_CRIT("cfg. parser: memory allocation"
										" failure while parsing host\n");
							YYABORT;
						}else{
							memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))]=*(yyvsp[-1].strval);
							memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
						}
						pkg_free((yyvsp[-2].strval)); pkg_free((yyvsp[0].strval));
					}
#line 2656 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 564 "cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
					yyerror("invalid hostname (use quotes if hostname "
						"has config keywords)"); }
#line 2664 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 569 "cfg.y" /* yacc.c:1646  */
    { IFOR();
		if (parse_proto((unsigned char *)(yyvsp[0].strval), strlen((yyvsp[0].strval)), &i_tmp) < 0) {
			yyerrorf("cannot handle protocol <%s>\n", (yyvsp[0].strval));
			YYABORT;
		}
		pkg_free((yyvsp[0].strval));
		(yyval.intval) = i_tmp;
	 }
#line 2677 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 579 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2683 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 580 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 2689 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 583 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2695 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 584 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2701 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 585 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=-(yyvsp[0].intval); }
#line 2707 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 589 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 2714 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 591 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 2721 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 593 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.sockid)=0;
				yyerror("port number expected");
				YYABORT;
				}
#line 2731 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 598 "cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0;
				yyerror("protocol expected");
				YYABORT;
			}
#line 2740 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 604 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-2].intval), 0); }
#line 2747 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 606 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-4].intval), (yyvsp[0].intval)); }
#line 2754 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 610 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2761 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 612 "cfg.y" /* yacc.c:1646  */
    { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2768 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 614 "cfg.y" /* yacc.c:1646  */
    { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2775 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 616 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.sockid)=0;
				yyerror(" port number expected");
				}
#line 2784 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 623 "cfg.y" /* yacc.c:1646  */
    { IFOR();  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 2790 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 624 "cfg.y" /* yacc.c:1646  */
    { IFOR(); (yyval.sockid)=(yyvsp[-1].sockid); (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 2796 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 627 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2803 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 629 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2810 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 631 "cfg.y" /* yacc.c:1646  */
    {
					(yyval.sockid)=0;
					yyerror(" port number expected");
					}
#line 2819 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 637 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.flags |= SI_IS_ANYCAST;
					}
#line 2827 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 640 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.flags |= SI_FRAG;
					}
#line 2835 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 643 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.workers=(yyvsp[0].intval);
					}
#line 2843 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 646 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.socket = (yyvsp[0].sockid);
					}
#line 2851 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 649 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.tag = (yyvsp[0].strval);
					}
#line 2859 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 652 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.auto_scaling_profile=(yyvsp[0].strval);
					}
#line 2867 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 661 "cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2873 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 662 "cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2879 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 663 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 2887 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 665 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 2895 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 668 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 2903 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 670 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 2911 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 675 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_NONE; }
#line 2917 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 676 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2923 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 678 "cfg.y" /* yacc.c:1646  */
    {  IFOR(); (yyval.multistr)=new_string((yyvsp[0].strval)); }
#line 2929 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 679 "cfg.y" /* yacc.c:1646  */
    { IFOR(); (yyval.multistr)=new_string((yyvsp[-1].strval)); (yyval.multistr)->next=(yyvsp[0].multistr); }
#line 2935 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 682 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,(yyvsp[-3].intval),(yyvsp[-7].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 2948 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 690 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,
				(yyvsp[-3].intval),(yyvsp[-7].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 2962 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 701 "cfg.y" /* yacc.c:1646  */
    {}
#line 2968 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 702 "cfg.y" /* yacc.c:1646  */
    {}
#line 2974 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 703 "cfg.y" /* yacc.c:1646  */
    { yyerror("bad black list element");}
#line 2980 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 710 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-17].strval),(yyvsp[-15].intval),(yyvsp[-13].intval),(yyvsp[-10].intval),(yyvsp[-8].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval),10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 2990 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 718 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-16].strval),(yyvsp[-14].intval),(yyvsp[-12].intval),(yyvsp[-9].intval),(yyvsp[-9].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval), 10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 3000 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 724 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-9].strval),(yyvsp[-7].intval),(yyvsp[-5].intval),(yyvsp[-2].intval),(yyvsp[0].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 3010 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 730 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-8].strval),(yyvsp[-6].intval),(yyvsp[-4].intval),(yyvsp[-1].intval),(yyvsp[-1].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 3020 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 737 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			/* in debug mode, force logging to DEBUG level*/
			*log_level = debug_mode?L_DBG:(yyvsp[0].intval);
			}
#line 3029 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 741 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (*(yyvsp[0].strval)) {
				int len = strlen((yyvsp[0].strval));
				char *buf = pkg_malloc(len + 2);
				if (!buf)
					yyerror("oom");
				sprintf(buf, "%s:", (yyvsp[0].strval));
				log_prefix = buf;
			} else {
				log_prefix = (yyvsp[0].strval);
			}
			}
#line 3046 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 753 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3052 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 754 "cfg.y" /* yacc.c:1646  */
    { IFOR(); enable_asserts=(yyvsp[0].intval); }
#line 3058 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 755 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3064 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 756 "cfg.y" /* yacc.c:1646  */
    { IFOR(); abort_on_assert=(yyvsp[0].intval); }
#line 3070 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 757 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3076 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 758 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			debug_mode=(yyvsp[0].intval);
			if (debug_mode) { *log_level = L_DBG;log_stderr=1;}
			}
#line 3085 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 763 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected for debug_mode"); }
#line 3091 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 766 "cfg.y" /* yacc.c:1646  */
    { IFOR(); log_stdout=(yyvsp[0].intval); }
#line 3097 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 767 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3103 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 771 "cfg.y" /* yacc.c:1646  */
    { IFOR(); if (!config_check && !debug_mode) log_stderr=(yyvsp[0].intval); }
#line 3109 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 772 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3115 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 773 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
				yyerror("bad facility (see syslog(3) man page)");
			if (!config_check)
				log_facility=i_tmp;
			}
#line 3126 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 779 "cfg.y" /* yacc.c:1646  */
    { yyerror("ID expected"); }
#line 3132 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 780 "cfg.y" /* yacc.c:1646  */
    { IFOR(); log_name=(yyvsp[0].strval); }
#line 3138 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 781 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3144 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 782 "cfg.y" /* yacc.c:1646  */
    { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 3150 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 783 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3156 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 784 "cfg.y" /* yacc.c:1646  */
    { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 3162 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 785 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3168 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 786 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_try_ipv6=(yyvsp[0].intval); }
#line 3174 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 787 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3180 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 788 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_try_naptr=(yyvsp[0].intval); }
#line 3186 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 789 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3192 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 790 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_retr_time=(yyvsp[0].intval); }
#line 3198 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 791 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3204 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 792 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_retr_no=(yyvsp[0].intval); }
#line 3210 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 793 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3216 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 794 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_servers_no=(yyvsp[0].intval); }
#line 3222 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 795 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3228 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 796 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_search_list=(yyvsp[0].intval); }
#line 3234 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 797 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3240 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 798 "cfg.y" /* yacc.c:1646  */
    { IFOR(); max_while_loops=(yyvsp[0].intval); }
#line 3246 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 799 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3252 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 800 "cfg.y" /* yacc.c:1646  */
    { IFOR(); maxbuffer=(yyvsp[0].intval); }
#line 3258 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 801 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3264 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 802 "cfg.y" /* yacc.c:1646  */
    { IFOR(); udp_workers_no=(yyvsp[0].intval); }
#line 3270 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 803 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				udp_workers_no=(yyvsp[-2].intval);
				udp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3279 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 807 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3285 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 808 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				timer_workers_no=(yyvsp[0].intval);
		}
#line 3293 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 811 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				timer_workers_no=(yyvsp[-2].intval);
				timer_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3302 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 815 "cfg.y" /* yacc.c:1646  */
    { check_via=(yyvsp[0].intval); }
#line 3308 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 816 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3314 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 817 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			shm_hash_split_percentage=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3327 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 825 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
				}
#line 3340 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 833 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			shm_secondary_hash_size=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3353 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 841 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3366 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 849 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_enabled = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3379 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 857 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3392 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 865 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_pattern_file = (yyvsp[0].strval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3405 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 873 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("string expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3418 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 881 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_percentage = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3431 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 889 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3444 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 897 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			rpm_mem_file = (yyvsp[0].strval);
			}
#line 3452 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 900 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3458 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 901 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			rpm_mem_size = (yyvsp[0].intval) * 1024 * 1024;
			}
#line 3466 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 904 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3472 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 905 "cfg.y" /* yacc.c:1646  */
    { IFOR(); memlog=(yyvsp[0].intval); memdump=(yyvsp[0].intval); }
#line 3478 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 906 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3484 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 907 "cfg.y" /* yacc.c:1646  */
    { IFOR(); memdump=(yyvsp[0].intval); }
#line 3490 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 908 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3496 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 909 "cfg.y" /* yacc.c:1646  */
    {  IFOR();execmsgthreshold=(yyvsp[0].intval); }
#line 3502 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 910 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3508 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 911 "cfg.y" /* yacc.c:1646  */
    { IFOR(); execdnsthreshold=(yyvsp[0].intval); }
#line 3514 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 912 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3520 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 913 "cfg.y" /* yacc.c:1646  */
    { IFOR(); tcpthreshold=(yyvsp[0].intval); }
#line 3526 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 914 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3532 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 915 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("SHM threshold has to be a percentage between"
					" 0 and 100");
			event_shm_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif /* STATISTICS */
			}
#line 3547 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 925 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3553 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 926 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef PKG_MALLOC
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("PKG threshold has to be a percentage between "
					"0 and 100");
			event_pkg_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif
			#else
			yyerror("pkg_malloc support not compiled in");
			#endif
			}
#line 3572 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 940 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3578 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 941 "cfg.y" /* yacc.c:1646  */
    { IFOR(); query_buffer_size=(yyvsp[0].intval); }
#line 3584 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 942 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3590 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 943 "cfg.y" /* yacc.c:1646  */
    { IFOR(); query_flush_time=(yyvsp[0].intval); }
#line 3596 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 944 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3602 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 945 "cfg.y" /* yacc.c:1646  */
    { IFOR(); sip_warning=(yyvsp[0].intval); }
#line 3608 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 946 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3614 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 947 "cfg.y" /* yacc.c:1646  */
    { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 3620 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 948 "cfg.y" /* yacc.c:1646  */
    { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 3626 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 949 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3632 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 950 "cfg.y" /* yacc.c:1646  */
    { IFOR(); working_dir=(yyvsp[0].strval); }
#line 3638 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 951 "cfg.y" /* yacc.c:1646  */
    { IFOR(); working_dir=(yyvsp[0].strval); }
#line 3644 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 952 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3650 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 953 "cfg.y" /* yacc.c:1646  */
    { IFOR(); mhomed=(yyvsp[0].intval); }
#line 3656 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 954 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3662 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 955 "cfg.y" /* yacc.c:1646  */
    { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
								}
#line 3677 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 965 "cfg.y" /* yacc.c:1646  */
    { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
									}
#line 3692 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 975 "cfg.y" /* yacc.c:1646  */
    { yyerror("poll method name expected"); }
#line 3698 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 976 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if ((yyvsp[0].intval) < TCP_ALIAS_NEVER || (yyvsp[0].intval) > TCP_ALIAS_ALWAYS)
					yyerror("invalid 'tcp_accept_aliases' value");
				tcp_accept_aliases=(yyvsp[0].intval);
		}
#line 3708 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 981 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3714 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 982 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_workers_no=(yyvsp[0].intval);
		}
#line 3722 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 985 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_workers_no=(yyvsp[-2].intval);
				tcp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3731 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 989 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3737 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 990 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if ((yyvsp[0].intval) <= 0)
					yyerror("invalid 'tcp_connect_timeout' (value too low!)");
				tcp_connect_timeout=(yyvsp[0].intval);
		}
#line 3747 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 995 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3753 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 996 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_con_lifetime=(yyvsp[0].intval);
		}
#line 3761 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 999 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3767 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1000 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_socket_backlog=(yyvsp[0].intval);
		}
#line 3775 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1003 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3781 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1004 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_max_connections=(yyvsp[0].intval);
		}
#line 3789 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1007 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3795 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1008 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_no_new_conn_bflag =
					get_flag_id_by_name(FLAG_TYPE_BRANCH, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_bflag ) )
					yyerror("invalid TCP no_new_conn Branch Flag");
				flag_idx2mask( &tcp_no_new_conn_bflag );
		}
#line 3807 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1015 "cfg.y" /* yacc.c:1646  */
    { yyerror("number value expected"); }
#line 3813 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1016 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_no_new_conn_rplflag =
					get_flag_id_by_name(FLAG_TYPE_MSG, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_rplflag ) )
					yyerror("invalid TCP no_new_conn RePLy Flag");
				flag_idx2mask( &tcp_no_new_conn_rplflag );
		}
#line 3825 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1023 "cfg.y" /* yacc.c:1646  */
    { yyerror("number value expected"); }
#line 3831 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1025 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_keepalive=!!(yyvsp[0].intval);
		}
#line 3839 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1028 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3845 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1029 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_max_msg_time=(yyvsp[0].intval);
		}
#line 3853 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1032 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3859 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1033 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_parallel_read_on_workers=!!(yyvsp[0].intval);
		}
#line 3867 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1036 "cfg.y" /* yacc.c:1646  */
    {
			yyerror("boolean value expected");
		}
#line 3875 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1039 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPCNT
				warn("cannot be enabled TCP_KEEPCOUNT (no OS support)");
			#else
				tcp_keepcount=(yyvsp[0].intval);
			#endif
		}
#line 3887 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1046 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3893 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1047 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPIDLE
				warn("cannot be enabled TCP_KEEPIDLE (no OS support)");
			#else
				tcp_keepidle=(yyvsp[0].intval);
			#endif
		}
#line 3905 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1054 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3911 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1055 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPINTVL
				warn("cannot be enabled TCP_KEEPINTERVAL (no OS support)");
			#else
				tcp_keepinterval=(yyvsp[0].intval);
			 #endif
		}
#line 3923 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1062 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3929 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1063 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							server_signature=(yyvsp[0].intval); }
#line 3936 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1065 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3942 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1066 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							server_header->s=(yyvsp[0].strval);
							server_header->len=strlen((yyvsp[0].strval));
							}
#line 3951 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1070 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3957 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1071 "cfg.y" /* yacc.c:1646  */
    { user_agent_header->s=(yyvsp[0].strval);
			user_agent_header->len=strlen((yyvsp[0].strval));
									}
#line 3965 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1074 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3971 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1075 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							pv_print_buf_size = (yyvsp[0].intval); }
#line 3978 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1077 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3984 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1078 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							xlog_buf_size = (yyvsp[0].intval); }
#line 3991 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1080 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							xlog_force_color = (yyvsp[0].intval); }
#line 3998 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1082 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							xlog_print_level = (yyvsp[0].intval); }
#line 4005 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1084 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4011 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1085 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4017 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1086 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4023 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1087 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							*xlog_level = (yyvsp[0].intval); }
#line 4030 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1089 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4036 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1090 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							if (add_listening_socket((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listening socket\n");
								break;
							}
						}
#line 4048 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1097 "cfg.y" /* yacc.c:1646  */
    { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 4056 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1100 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							warn("'listen' is deprecated, use 'socket' instead");
							if (add_listening_socket((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listen address\n");
								break;
							}
						}
#line 4069 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1108 "cfg.y" /* yacc.c:1646  */
    { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 4077 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1111 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							/* convert STIRNG ($3) to an ID */
							/* update the memstats type for each module */
							#ifndef SHM_EXTRA_STATS
								LM_CRIT("SHM_EXTRA_STATS not defined");
								YYABORT;
							#else

							#ifdef SHM_SHOW_DEFAULT_GROUP
							if(strcmp((yyvsp[-2].strval), "default") == 0){
								LM_CRIT("default group  name is not allowed");
								YYABORT;
							}
							#endif

							for(tmp_mod = mod_names; tmp_mod; tmp_mod=tmp_mod->next){
								if(strcmp((yyvsp[-2].strval), tmp_mod->s) == 0){
									LM_CRIT("The same mem-group name is used twice: [%s] [%s]\n", (yyvsp[-2].strval), tmp_mod->s);
									YYABORT;
								}
							}

							tmp_mod = pkg_malloc(sizeof(struct multi_str));
							if(!tmp_mod){
								LM_CRIT("out of pkg memory");
								YYABORT;
							}

							tmp_mod->s = (yyvsp[-2].strval);
							tmp_mod->next = mod_names;
							mod_names = tmp_mod;
							for (tmp_mod = (yyvsp[0].multistr); tmp_mod; tmp_mod = tmp_mod->next){
								if(set_mem_idx(tmp_mod->s, mem_free_idx)){
									YYABORT;
								}
							}

							mem_free_idx++;

							if(alloc_group_stat()){
								YYABORT;
							}
							#endif
						}
#line 4126 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1155 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid or no module specified"); }
#line 4132 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1156 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next)
								add_alias(lst_tmp->name, strlen(lst_tmp->name),
											lst_tmp->port, lst_tmp->proto);
							  }
#line 4142 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1161 "cfg.y" /* yacc.c:1646  */
    { yyerror("hostname expected (use quotes"
							" if the hostname includes config keywords)"); }
#line 4149 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1163 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								auto_aliases=(yyvsp[0].intval); }
#line 4156 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1165 "cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 4162 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1166 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								if ((yyvsp[0].strval)) {
									default_global_address->s=(yyvsp[0].strval);
									default_global_address->len=strlen((yyvsp[0].strval));
								}
								}
#line 4173 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1172 "cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname "
												"expected"); }
#line 4180 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1174 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								tmp = int2str((yyvsp[0].intval), &i_tmp);
								if (i_tmp > default_global_port->len)
									default_global_port->s =
									pkg_realloc(default_global_port->s, i_tmp);
								if (!default_global_port->s) {
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								} else {
									default_global_port->len = i_tmp;
									memcpy(default_global_port->s, tmp,
											default_global_port->len);
								}
								}
#line 4199 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1188 "cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname "
												"expected"); }
#line 4206 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1190 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										disable_core_dump=(yyvsp[0].intval);
									}
#line 4214 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1193 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4220 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1194 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										open_files_limit=(yyvsp[0].intval);
									}
#line 4228 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1197 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4234 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1198 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								#ifdef USE_MCAST
										mcast_loopback=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4246 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1205 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4252 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1206 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								#ifdef USE_MCAST
										mcast_ttl=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4264 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1213 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected as tos"); }
#line 4270 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1214 "cfg.y" /* yacc.c:1646  */
    { IFOR(); tos = (yyvsp[0].intval);
							if (tos<=0)
								yyerror("invalid tos value");
		 }
#line 4279 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1218 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
								tos=IPTOS_LOWDELAY;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
								tos=IPTOS_THROUGHPUT;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
								tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
								tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
								tos=IPTOS_LOWCOST;
#endif
							} else {
								yyerror("invalid tos value - allowed: "
									"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
									"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
									",IPTOS_LOWCOST"
#endif
#if defined(IPTOS_MINCOST)
									",IPTOS_MINCOST"
#endif
									"\n");
							}
		 }
#line 4312 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1246 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4318 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1247 "cfg.y" /* yacc.c:1646  */
    {IFOR();
				set_mpath((yyvsp[0].strval)); }
#line 4325 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1249 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4331 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1250 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										disable_dns_failover=(yyvsp[0].intval);
									}
#line 4339 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1253 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4345 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1254 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										disable_dns_blacklist=(yyvsp[0].intval);
									}
#line 4353 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1257 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4359 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1258 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				s_tmp.s = (yyvsp[-4].strval);
				s_tmp.len = strlen((yyvsp[-4].strval));
				if (create_bl_head( BL_CORE_ID, BL_READONLY_LIST,
				    bl_head, bl_tail, &s_tmp)==0) {
					yyerror("failed to create blacklist\n");
					YYABORT;
				}
				bl_head = bl_tail = NULL;
				}
#line 4374 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1268 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				sl_fwd_disabled=(yyvsp[0].intval); }
#line 4381 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1270 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				db_version_table=(yyvsp[0].strval); }
#line 4388 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1272 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4394 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1273 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				db_default_url=(yyvsp[0].strval); }
#line 4401 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1275 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4407 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1276 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				db_max_async_connections=(yyvsp[0].intval); }
#line 4414 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1278 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("integer value expected");
				}
#line 4422 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1281 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				disable_503_translation=(yyvsp[0].intval); }
#line 4429 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1283 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("integer value expected");
				}
#line 4437 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1286 "cfg.y" /* yacc.c:1646  */
    {}
#line 4443 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1287 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("bad auto-scaling profile definition");
				}
#line 4451 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1290 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				auto_scaling_cycle=(yyvsp[0].intval); }
#line 4458 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1292 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("integer value expected");
				}
#line 4466 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1295 "cfg.y" /* yacc.c:1646  */
    { yyerror("unknown config variable"); }
#line 4472 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1298 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (load_module((yyvsp[0].strval)) < 0)
				yyerrorf("failed to load module %s\n", (yyvsp[0].strval));
		}
#line 4481 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1302 "cfg.y" /* yacc.c:1646  */
    { yyerror("string expected");  }
#line 4487 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1303 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), STR_PARAM, (yyvsp[-1].strval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 4498 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1309 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), INT_PARAM, (void*)(yyvsp[-1].intval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 4509 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1315 "cfg.y" /* yacc.c:1646  */
    { yyerror("Invalid arguments"); }
#line 4515 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1319 "cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4521 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1320 "cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4527 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1323 "cfg.y" /* yacc.c:1646  */
    {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv4 address");
						}
					}
				}
#line 4546 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1339 "cfg.y" /* yacc.c:1646  */
    {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET6;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv6 address");
						}
					}
				}
#line 4565 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1355 "cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4571 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1356 "cfg.y" /* yacc.c:1646  */
    {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 4577 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1359 "cfg.y" /* yacc.c:1646  */
    {
				if (parse_ipnet((yyvsp[0].strval), strlen((yyvsp[0].strval)), &net_tmp) < 0)
					yyerror("unable to parse ip and/or netmask\n");

				(yyval.ipnet) = net_tmp;
			}
#line 4588 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1365 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.ipnet)=mk_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8);
				pkg_free((yyvsp[0].ipaddr));
			}
#line 4597 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1375 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					yyerror("cfg. parser: out of memory");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 4612 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1385 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					LM_CRIT("ERROR: cfg. parser: out of memory.\n");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 4627 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1396 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = (yyvsp[0].strval);
				}
#line 4635 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1399 "cfg.y" /* yacc.c:1646  */
    {
				tmp=int2str((yyvsp[0].intval), &i_tmp);
				if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
					yyerror("cfg. parser: out of memory.\n");
					YYABORT;
				}
				memcpy( (yyval.strval), tmp, i_tmp);
				(yyval.strval)[i_tmp] = 0;
				}
#line 4649 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1408 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = (yyvsp[0].strval);
		}
#line 4657 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1413 "cfg.y" /* yacc.c:1646  */
    {
				/* check to see if there are any "$" in the string name */
				tmp = strchr((yyvsp[0].strval), '$');
				if (!tmp) {
					/* route name is a cosntant string - search for the route */
					rn_tmp.data = 0;
					rn_tmp.iname = get_script_route_idx((yyvsp[0].strval), sroutes->request,
							RT_NO, 0);
					if (rn_tmp.iname==-1)
						yyerror("too many script routes");
					(yyval.intval) = NUMBER_ST;
				} else {
					tstr.s = (yyvsp[0].strval);
					tstr.len = strlen(tstr.s);
					if (pv_parse_format(&tstr, &elem) < 0) {
						yyerror("cannot parse format");
						YYABORT;
					}
					/* the route name is a format, so we can't evaluate it now */
					rn_tmp.ename = elem;
					(yyval.intval) = SCRIPTVAR_ELEM_ST;
				}
			}
#line 4685 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1436 "cfg.y" /* yacc.c:1646  */
    {
				rn_tmp.sname = (yyvsp[0].specval);
				(yyval.intval) = SCRIPTVAR_ST;
		}
#line 4694 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1441 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->request[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"request routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
					}
#line 4707 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1449 "cfg.y" /* yacc.c:1646  */
    {
						if ( strtol((yyvsp[-4].strval),&tmp,10)==0 && *tmp==0) {
							/* route[0] detected */
							if (sroutes->request[DEFAULT_RT].a!=0) {
								yyerror("overwriting(2) default "
									"request routing table");
								YYABORT;
							}
							push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
						} else {
							i_tmp = get_script_route_idx( (yyvsp[-4].strval),
								sroutes->request, RT_NO,1);
							if (i_tmp==-1) YYABORT;
							push((yyvsp[-1].action), &sroutes->request[i_tmp].a);
						}
					}
#line 4728 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1465 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  route  statement"); }
#line 4734 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1468 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->failure,
							FAILURE_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->failure[i_tmp].a);
					}
#line 4745 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1474 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid failure_route statement"); }
#line 4751 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1477 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->onreply[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"onreply routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->onreply[DEFAULT_RT].a);
					}
#line 4764 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1485 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->onreply,
							ONREPLY_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->onreply[i_tmp].a);
					}
#line 4775 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1491 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 4781 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1494 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->branch,
							BRANCH_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->branch[i_tmp].a);
					}
#line 4792 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1500 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid branch_route statement"); }
#line 4798 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1503 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->error.a!=0) {
							yyerror("overwriting default "
								"error routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->error.a);
					}
#line 4811 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1511 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid error_route statement"); }
#line 4817 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1514 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->local.a!=0) {
							yyerror("re-definition of local "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->local.a);
					}
#line 4830 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1522 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid local_route statement"); }
#line 4836 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1525 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->startup.a!=0) {
							yyerror("re-definition of startup "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->startup.a);
					}
#line 4849 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1533 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid startup_route statement"); }
#line 4855 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1536 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = 0;
						while(i_tmp<TIMER_RT_NO && sroutes->timer[i_tmp].a!=0){
							i_tmp++;
						}
						if(i_tmp == TIMER_RT_NO) {
							yyerror("Too many timer routes defined\n");
							YYABORT;
						}
						sroutes->timer[i_tmp].name = (yyvsp[-6].strval);
						sroutes->timer[i_tmp].interval = (yyvsp[-4].intval);
						push((yyvsp[-1].action), &sroutes->timer[i_tmp].a);
					}
#line 4873 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1549 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid timer_route statement"); }
#line 4879 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1552 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx((yyvsp[-4].strval), sroutes->event,
								EVENT_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->event[i_tmp].a);
					}
#line 4890 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1558 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid event_route statement"); }
#line 4896 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1563 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(AND_OP, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4902 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1564 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(OR_OP, (yyvsp[-2].expr), (yyvsp[0].expr));  }
#line 4908 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1565 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(NOT_OP, (yyvsp[0].expr), 0);  }
#line 4914 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1566 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(EVAL_OP, (yyvsp[-1].expr), 0); }
#line 4920 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1567 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=(yyvsp[-1].expr); }
#line 4926 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1568 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=(yyvsp[0].expr); }
#line 4932 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1571 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 4938 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1572 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 4944 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1575 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GT_OP; }
#line 4950 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1576 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LT_OP; }
#line 4956 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1577 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GTE_OP; }
#line 4962 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1578 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LTE_OP; }
#line 4968 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1580 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=MATCH_OP; }
#line 4974 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1581 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=NOTMATCH_OP; }
#line 4980 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1584 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 4986 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1585 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 4992 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1588 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 4998 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1589 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5004 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1590 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5010 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1593 "cfg.y" /* yacc.c:1646  */
    {
				spec = (pv_spec_t*)pkg_malloc(sizeof(pv_spec_t));
				if (spec==NULL){
					yyerror("no more pkg memory\n");
					YYABORT;
				}
				memset(spec, 0, sizeof(pv_spec_t));
				tstr.s = (yyvsp[0].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_spec(&tstr, spec)==NULL)
				{
					yyerror("unknown script variable");
				}

				(yyval.specval) = spec;
			}
#line 5031 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1609 "cfg.y" /* yacc.c:1646  */
    {
			(yyval.specval)=0; yyerror("invalid script variable name");
		}
#line 5039 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1614 "cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=(yyvsp[0].expr); }
#line 5045 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1615 "cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5051 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1616 "cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem( NO_OP, NUMBER_O, 0, NUMBER_ST,
											(void*)(yyvsp[0].intval) ); }
#line 5058 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1618 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem(NO_OP, SCRIPTVAR_O,0,SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5066 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1623 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5074 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1626 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),STR_ST,(yyvsp[0].strval));
			}
#line 5082 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1629 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),NUMBER_ST,(void *)(yyvsp[0].intval));
			}
#line 5090 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1632 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval), NULLV_ST, 0);
			}
#line 5098 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1635 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem((yyvsp[-1].intval), SCRIPTVAR_O, (void*)(yyvsp[-2].specval), NET_ST, (yyvsp[0].ipnet));
			}
#line 5106 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1641 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = EQ_T; }
#line 5112 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1642 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = COLONEQ_T; }
#line 5118 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1643 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = PLUSEQ_T; }
#line 5124 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1644 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = MINUSEQ_T;}
#line 5130 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1645 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = DIVEQ_T; }
#line 5136 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1646 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = MULTEQ_T; }
#line 5142 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1647 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = MODULOEQ_T; }
#line 5148 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1648 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BANDEQ_T; }
#line 5154 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1649 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BOREQ_T; }
#line 5160 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1650 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BXOREQ_T; }
#line 5166 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1654 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = mk_elem(VALUE_OP, NUMBERV_O, (void*)(yyvsp[0].intval), 0, 0); }
#line 5172 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1655 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = mk_elem(VALUE_OP, STRINGV_O, (yyvsp[0].strval), 0, 0); }
#line 5178 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1656 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = mk_elem(VALUE_OP, SCRIPTVAR_O, (yyvsp[0].specval), 0, 0); }
#line 5184 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1657 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)= (yyvsp[0].expr); }
#line 5190 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1658 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5196 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1659 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(PLUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5204 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1662 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(MINUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5212 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1665 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(MULT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5220 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1668 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(DIV_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5228 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1671 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(MODULO_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5236 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1674 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BAND_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5244 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1677 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5252 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1680 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BXOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5260 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1683 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BLSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5268 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1686 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BRSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5276 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1689 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BNOT_OP, EXPR_O, (yyvsp[0].expr), 0, 0);
			}
#line 5284 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1692 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 5290 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1695 "cfg.y" /* yacc.c:1646  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), (yyvsp[-1].intval),
					SCRIPTVAR_ST,
					EXPR_ST,
					(yyvsp[-2].specval),
					(yyvsp[0].expr));
		}
#line 5308 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1708 "cfg.y" /* yacc.c:1646  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), EQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5326 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1721 "cfg.y" /* yacc.c:1646  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			/* not all can get NULL with := */
			switch((yyvsp[-2].specval)->type) {
				case PVT_AVP:
				break;
				default:
					yyerror("invalid left operand in NULL assignment");
			}
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), COLONEQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5351 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1743 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5357 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1744 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5363 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1745 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5369 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1746 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 5375 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1747 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; }
#line 5381 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1750 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5387 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1751 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 5393 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1752 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; }
#line 5399 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1755 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5405 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1756 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 5411 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1757 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; }
#line 5417 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1760 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5423 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1761 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5429 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1762 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command!)"); }
#line 5435 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1766 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5441 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1767 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5447 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1768 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command!)"); }
#line 5453 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1771 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 5459 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 1772 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5465 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1773 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5471 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1774 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5477 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1775 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5483 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1776 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 5489 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1777 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 5495 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 1778 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 5501 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1781 "cfg.y" /* yacc.c:1646  */
    { mk_action0((yyval.action), BREAK_T);}
#line 5507 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1782 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 5513 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1783 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5519 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1784 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5525 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1785 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5531 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1786 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5537 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 1787 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 5543 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 1788 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 5549 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 1789 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 5555 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 1792 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 5568 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1800 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 5581 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 1810 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 5594 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1818 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 5607 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 1828 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), WHILE_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action));
									}
#line 5618 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 1836 "cfg.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-4].specval)->type != PVT_SCRIPTVAR &&
					    (yyvsp[-4].specval)->type != PVT_AVP &&
						pv_type((yyvsp[-4].specval)->type) != PVT_JSON) {
						yyerror("\nfor-each statement: only \"var\", \"avp\" "
					            "and \"json\" iterators are supported!");
					}

					mk_action3( (yyval.action), FOR_EACH_T,
					            SCRIPTVAR_ST,
					            SCRIPTVAR_ST,
					            ACTIONS_ST,
					            (yyvsp[-4].specval),
					            (yyvsp[-2].specval),
					            (yyvsp[0].action));
					}
#line 5639 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 1854 "cfg.y" /* yacc.c:1646  */
    {
											mk_action2( (yyval.action), SWITCH_T,
														SCRIPTVAR_ST,
														ACTIONS_ST,
														(yyvsp[-4].specval),
														(yyvsp[-1].action));
									}
#line 5651 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 1863 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5657 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 1864 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5663 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 1866 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5669 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 1867 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5675 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 1870 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].intval),
													(yyvsp[0].action));
											}
#line 5686 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 1876 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].intval),
													NULL);
							}
#line 5697 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 1882 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].strval),
													(yyvsp[0].action));
											}
#line 5708 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 1888 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].strval),
													NULL);
							}
#line 5719 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 1896 "cfg.y" /* yacc.c:1646  */
    { mk_action1( (yyval.action), DEFAULT_T,
													ACTIONS_ST, (yyvsp[0].action));
									}
#line 5727 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 1899 "cfg.y" /* yacc.c:1646  */
    { mk_action1( (yyval.action), DEFAULT_T, ACTIONS_ST, NULL); }
#line 5733 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 1902 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = STR_ST;
										elems[1].u.data = (yyvsp[0].strval);
										(yyval.intval)=1;
										}
#line 5743 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 1907 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = STR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].strval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 5758 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 1917 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NULLV_ST;
										elems[2].u.data = NULL;
										(yyval.intval)=2;
										}
#line 5770 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 1924 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = STR_ST;
										elems[2].u.data = (yyvsp[0].strval);
										(yyval.intval)=2;
										}
#line 5782 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 1931 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-1].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-1].intval)+1].type = NULLV_ST;
										elems[(yyvsp[-1].intval)+1].u.data = NULL;
										(yyval.intval)=(yyvsp[-1].intval)+1;
										}
#line 5797 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 1941 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NUMBER_ST;
										elems[1].u.number = (yyvsp[0].intval);
										(yyval.intval)=1;
										}
#line 5807 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 1946 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NUMBER_ST;
										elems[2].u.number = (yyvsp[0].intval);
										(yyval.intval)=2;
										}
#line 5819 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 1953 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = NUMBER_ST;
										elems[(yyvsp[-2].intval)+1].u.number = (yyvsp[0].intval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 5834 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 1963 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = SCRIPTVAR_ST;
										elems[1].u.data = (yyvsp[0].specval);
										(yyval.intval)=1;
										}
#line 5844 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 1968 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = SCRIPTVAR_ST;
										elems[2].u.data = (yyvsp[0].specval);
										(yyval.intval)=2;
										}
#line 5856 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 1975 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = SCRIPTVAR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].specval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 5871 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 1987 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = STRING_ST;
						route_elems[0].u.string = (yyvsp[0].strval);
						(yyval.intval)=1;
			}
#line 5881 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 1992 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = NUMBER_ST;
						route_elems[0].u.number = (long)(yyvsp[0].intval);
						(yyval.intval)=1;
			}
#line 5891 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 1997 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = NULLV_ST;
						route_elems[0].u.data = 0;
						(yyval.intval)=1;
			}
#line 5901 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2002 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = SCRIPTVAR_ST;
						route_elems[0].u.data = (yyvsp[0].specval);
						(yyval.intval)=1;
			}
#line 5911 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2007 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = STRING_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].strval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5926 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2017 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NUMBER_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (void*)(long)(yyvsp[0].intval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5941 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2027 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = SCRIPTVAR_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].specval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5956 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2037 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NULLV_ST;
							route_elems[(yyvsp[-2].intval)].u.data = 0;
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5971 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2049 "cfg.y" /* yacc.c:1646  */
    {
				cmd_tmp=(void*)find_mod_acmd_export_t((yyvsp[-2].strval));
				if (cmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-2].strval));
					(yyval.action)=0;
				}else{
					if (check_acmd_call_params(cmd_tmp,elems,0)<0) {
						yyerrorf("too few parameters "
							"for command <%s>\n", (yyvsp[-2].strval));
						(yyval.action)=0;
					} else {
						elems[0].type = ACMD_ST;
						elems[0].u.data = cmd_tmp;
						mk_action_((yyval.action), AMODULE_T, 1, elems);
					}
				}
			}
#line 5994 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2067 "cfg.y" /* yacc.c:1646  */
    {
				cmd_tmp=(void*)find_mod_acmd_export_t((yyvsp[-3].strval));
				if (cmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-3].strval));
					(yyval.action)=0;
				}else{
					rc = check_acmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
					switch (rc) {
					case -1:
						yyerrorf("too few parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -2:
						yyerrorf("too many parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -3:
						yyerrorf("mandatory parameter "
							" omitted for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					default:
						elems[0].type = ACMD_ST;
						elems[0].u.data = cmd_tmp;
						mk_action_((yyval.action), AMODULE_T, (yyvsp[-1].intval)+1, elems);
					}
				}
			}
#line 6030 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2098 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.action)=0;
				yyerrorf("bad arguments for command <%s>", (yyvsp[-3].strval));
			}
#line 6039 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2102 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.action)=0;
				yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6048 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2108 "cfg.y" /* yacc.c:1646  */
    {
			mk_action2( (yyval.action), ASSERT_T, EXPR_ST, STRING_ST, (yyvsp[-3].expr), (yyvsp[-1].strval));
			}
#line 6056 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2111 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), DROP_T); }
#line 6062 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2112 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), DROP_T); }
#line 6068 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2113 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), EXIT_T); }
#line 6074 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2114 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), EXIT_T); }
#line 6080 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2116 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[0].specval)); }
#line 6086 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2118 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[-1].specval)); }
#line 6092 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2120 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[0].intval)); }
#line 6098 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2122 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[-1].intval)); }
#line 6104 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2124 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 6110 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2125 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 6116 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2126 "cfg.y" /* yacc.c:1646  */
    {mk_action2( (yyval.action), LOG_T, NUMBER_ST,
													STRING_ST,(void*)4,(yyvsp[-1].strval));
									}
#line 6124 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2129 "cfg.y" /* yacc.c:1646  */
    {mk_action2( (yyval.action), LOG_T,
																NUMBER_ST,
																STRING_ST,
																(void*)(yyvsp[-3].intval),
																(yyvsp[-1].strval));
												}
#line 6135 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2135 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6141 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2136 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad log"
									"argument"); }
#line 6148 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2138 "cfg.y" /* yacc.c:1646  */
    {mk_action2( (yyval.action), ERROR_T,
																STRING_ST,
																STRING_ST,
																(yyvsp[-3].strval),
																(yyvsp[-1].strval));
												  }
#line 6159 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2144 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6165 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2145 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad error"
														"argument"); }
#line 6172 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2147 "cfg.y" /* yacc.c:1646  */
    {
						mk_action2( (yyval.action), ROUTE_T, (yyvsp[-1].intval), 0, rn_tmp.data, 0);
					}
#line 6180 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2151 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-1].intval) <= 0) yyerror("too many route parameters");

						/* duplicate the list */
						a_tmp = pkg_malloc((yyvsp[-1].intval) * sizeof(action_elem_t));
						if (!a_tmp) {
							yyerror("no more pkg memory");
							YYABORT;
						}
						memcpy(a_tmp, route_elems, (yyvsp[-1].intval)*sizeof(action_elem_t));

						mk_action3( (yyval.action), ROUTE_T, (yyvsp[-3].intval),	/* route idx */
							NUMBER_ST,					/* number of params */
							SCRIPTVAR_ST,				/* parameters */
							rn_tmp.data,
							(void*)(long)(yyvsp[-1].intval),
							(void*)a_tmp);
					}
#line 6203 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2170 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6209 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2171 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad route"
						"argument"); }
#line 6216 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2173 "cfg.y" /* yacc.c:1646  */
    {
								cmd_tmp=(void*)find_cmd_export_t((yyvsp[-2].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-2].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-2].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-2].strval));
									}
									(yyval.action)=0;
								}else{
									if (check_cmd_call_params(cmd_tmp,elems,0)<0) {
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-2].strval));
										(yyval.action)=0;
									} else {
										elems[0].type = CMD_ST;
										elems[0].u.data = cmd_tmp;
										mk_action_((yyval.action), CMD_T, 1, elems);
									}
								}
							}
#line 6244 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2196 "cfg.y" /* yacc.c:1646  */
    {
								cmd_tmp=(void*)find_cmd_export_t((yyvsp[-3].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-3].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-3].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-3].strval));
									}
									(yyval.action)=0;
								}else{
									rc = check_cmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
									switch (rc) {
									case -1:
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -2:
										yyerrorf("too many parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -3:
										yyerrorf("mandatory parameter "
											"omitted for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									default:
										elems[0].type = CMD_ST;
										elems[0].u.data = cmd_tmp;
										mk_action_((yyval.action), CMD_T, (yyvsp[-1].intval)+1, elems);
									}
								}
							}
#line 6285 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2232 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerrorf("bad arguments for "
												"command <%s>", (yyvsp[-3].strval)); }
#line 6292 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2234 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
			yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6300 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2237 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6307 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2239 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6314 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2241 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6321 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2243 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6328 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2245 "cfg.y" /* yacc.c:1646  */
    {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6335 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 2247 "cfg.y" /* yacc.c:1646  */
    {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6342 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2249 "cfg.y" /* yacc.c:1646  */
    {
				i_tmp = get_script_route_idx( (yyvsp[-1].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action2((yyval.action), ASYNC_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-3].action), (void*)(long)i_tmp);
				}
#line 6353 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2255 "cfg.y" /* yacc.c:1646  */
    {
				i_tmp = get_script_route_idx( (yyvsp[-3].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action3((yyval.action), ASYNC_T, ACTIONS_ST, NUMBER_ST, NUMBER_ST,
						(yyvsp[-5].action), (void*)(long)i_tmp, (void*)(long)(yyvsp[-1].intval));
				}
#line 6364 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2261 "cfg.y" /* yacc.c:1646  */
    {
				i_tmp = get_script_route_idx( (yyvsp[-3].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action3((yyval.action), LAUNCH_T, ACTIONS_ST, NUMBER_ST, STRING_ST,
						(yyvsp[-5].action), (void*)(long)i_tmp, (yyvsp[-1].strval));
				}
#line 6375 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2267 "cfg.y" /* yacc.c:1646  */
    {
				i_tmp = get_script_route_idx( (yyvsp[-1].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-3].action), (void*)(long)i_tmp);
				}
#line 6386 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2273 "cfg.y" /* yacc.c:1646  */
    {
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-1].action), (void*)(long)-1);
				}
#line 6395 "cfg.tab.c" /* yacc.c:1646  */
    break;


#line 6399 "cfg.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2280 "cfg.y" /* yacc.c:1906  */


static inline void ALLOW_UNUSED warn(char* s)
{
	LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
}

static void yyerror(char* s)
{
	cfg_dump_backtrace();
	LM_CRIT("parse error in %s:%d:%d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
	_cfg_dump_context(get_cfg_file_name, line, startcolumn, column, 1);
	cfg_errors++;
}

#define ERROR_MAXLEN 1024
static void yyerrorf(char *fmt, ...)
{
	char *tmp = pkg_malloc(ERROR_MAXLEN);
	va_list ap;
	va_start(ap, fmt);

	vsnprintf(tmp, ERROR_MAXLEN, fmt, ap);
	yyerror(tmp);

	pkg_free(tmp);
	va_end(ap);
}


static struct socket_id* mk_listen_id(char* host, enum sip_protos proto,
																	int port)
{
	struct socket_id* l;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0){
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		memset(l, 0, sizeof(*l));
		l->name     = host;
		l->proto    = proto;
		l->port     = port;
	}

	return l;
}

static void fill_socket_id(struct listen_param *param, struct socket_id *s)
{
	s->flags |= param->flags;
	s->workers = param->workers;
	s->auto_scaling_profile = param->auto_scaling_profile;
	if (param->socket)
		set_listen_id_adv(s, param->socket->name, param->socket->port);
	s->tag = param->tag;
}

static struct multi_str *new_string(char *s)
{
	struct multi_str *ms = pkg_malloc(sizeof(struct multi_str));
	if (!ms) {
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		ms->s    = s;
		ms->next = NULL;
	}
	return ms;
}

static struct socket_id* set_listen_id_adv(struct socket_id* sock,
											char *adv_name,
											int adv_port)
{
	sock->adv_name=adv_name;
	sock->adv_port=adv_port;
	return sock;
}

static int parse_ipnet(char *in, int len, struct net **ipnet)
{
	char *p = NULL;
	str ip_s, mask_s;
	struct ip_addr *ip = NULL, *mask = NULL, *ip_tmp;
	int af;
	unsigned int bitlen;

	p = q_memchr(in, '.', len);
	if (p)
		af = AF_INET;
	else if (q_memchr(in, ':', len)) {
		af = AF_INET6;
	} else {
		LM_ERR("Not an IP");
		return -1;
	}

	p = q_memchr(in, '/', len);
	if (!p) {
		LM_ERR("No netmask\n");
		return -1;
	}
	ip_s.s = in;
	ip_s.len = p - in;

	mask_s.s = p + 1;
	mask_s.len = len - ip_s.len - 1;
	if (!mask_s.s || mask_s.len == 0) {
		LM_ERR("Empty netmask\n");
		return -1;
	}

	ip_tmp = (af == AF_INET) ? str2ip(&ip_s) : str2ip6(&ip_s);
	if (!ip_tmp) {
		LM_ERR("Invalid IP\n");
		return -1;
	}
	ip = pkg_malloc(sizeof *ip);
	if (!ip) {
		LM_CRIT("No more pkg memory\n");
		return -1;
	}
	memcpy(ip, ip_tmp, sizeof *ip);

	p = (af == AF_INET) ? q_memchr(p, '.', len-(p-in)+1) : q_memchr(p, ':', len-(p-in)+1);
	if (p) {
		ip_tmp = (af == AF_INET) ? str2ip(&mask_s) : str2ip6(&mask_s);
		if (!ip_tmp) {
			LM_ERR("Invalid netmask\n");
			return -1;
		}
		mask = pkg_malloc(sizeof *mask);
		if (!mask) {
			LM_CRIT("No more pkg memory\n");
			return -1;
		}
		memcpy(mask, ip_tmp, sizeof *mask);

		*ipnet = mk_net(ip, mask);
	} else {
		if (str2int(&mask_s, &bitlen) < 0) {
			LM_ERR("Invalid netmask bitlen\n");
			return -1;
		}

		*ipnet = mk_net_bitlen(ip, bitlen);
	}

	pkg_free(ip);
	pkg_free(mask);

	if (*ipnet == NULL)
			return -1;

	return 0;
}
